var GuestCtrl = function () {

    var startedType = "started";

    var OTP_DATA = {
        "email" : "",
        "OTP" : "",
        "ADMIN_OTP" : [],
    };

    return {

        pageShowLogin : function(event,ui,pageId){
            $("#user_login #user_email").val(activation_data.email ? activation_data.email :"");
        },

        pageShowRegister : function(event,ui,pageId){
            $("#user_register #user_email").val(activation_data.email ? activation_data.email :"");
        },

        pageShowMobileVerification : function(event,ui,pageId){
            Application.setPageTitle(pageId,OTP_DATA.user_mobile_no);
            $("#user_mobile_verification #user_id").val(OTP_DATA.user_id);
            $("#user_mobile_verification #user_email").val(OTP_DATA.user_email);
            $("#user_mobile_verification #user_mobile_no").val(OTP_DATA.user_mobile_no);
        },

        pageShowAboutUs : function(event,ui,pageId){
            if(!Application.getPageShow(pageId))
                GuestCtrl.refreshContent('about_us');
        },

        pageShowTerms : function(event,ui,pageId){
            if(!Application.getPageShow(pageId))
                GuestCtrl.refreshContent('terms');
        },

        refreshAboutUs : function(){GuestCtrl.refreshContent('about_us');},

        refreshTerms : function(){GuestCtrl.refreshContent('terms');},

        refreshContent : function(page){
            var success = function(response){
                if(response.status=="1"){
                    if(page=="about_us"){
                        $('#static_about .page-working-wrapper').html(response.data);
                    }else{
                        $('#static_legal .page-working-wrapper').html(response.data);
                    }
                }else{
                    Notification.toast({message:response.message,alert:true});
                }
            };
            AJAX.call({
                url : {abs:"auth/getpage/page_type/"+page},
                async : true,
                success : success
            });
        },

        pageShowContact : function(event,ui,pageId){
            $('#static_contact #guest_name').val(ProfileCtrl.getUserProfile('user_name'));
            $('#static_contact #guest_email').val(ProfileCtrl.getUserProfile('user_email'));
            $('#static_contact #guest_phone').val(ProfileCtrl.getUserProfile('user_mobile_no'));
        },

        pageInitIndex : function(event,ui,pageId) {

            var screen = $.mobile.getScreenHeight();

            var page_id = "#user_index";

            var header = $(page_id+" .ui-header").hasClass("ui-header-fixed") ? $(page_id+" .ui-header").outerHeight() - 1 : $(page_id+" .ui-header").outerHeight();

            var footer = $(page_id+" .ui-footer").hasClass("ui-footer-fixed") ? $(page_id+" .ui-footer").outerHeight() - 1 : $(page_id+" .ui-footer").outerHeight();

            var contentCurrent = $(page_id+" .ui-content").outerHeight() - $(page_id+" .ui-content").height();

            var content = screen - header - footer - contentCurrent;

            var image_height = content-10 -48 -24;

            $("#swiper-home-page img").height(image_height);

            setTimeout(function () {
                IMAGE.initSwiper({time: "home-page"});
            }, 100);
        },

        /*
        * Method Login With LinkedIn
        * */

        FacebookLogin : function(){

            var success = function(response,extra){

                var token = false;

                if(isApp){
                    token = response.authResponse.accessToken;
                }else{
                    token = response;
                }

                var success = function(response){
                    if(response.status){
                        response.type = "login";
                        GuestCtrl.onLoginResponse(response);
                    }else{
                        Notification.toast({message:response.message,alert:true});
                    }
                };

                var error = function(response){
                    Notification.toast({message:"Something went wrong ! Please try later",alert:true});
                };

                AJAX.call({
                    url : {abs:"auth/facebook"},
                    async:true,
                    success : success,
                    data:{alt:"json",access_token:token},
                    error : error
                });
            };

            var error = function(response){
                Notification.toast({message:"Unable to connect ! Please try later ",alert:true});
            };

            if(isApp){
                if (window.cordova.platformId == "browser") {
                    var appId = "1868652930027972";// Please provide App Id here
                    facebookConnectPlugin.browserInit(appId);
                }
                facebookConnectPlugin.login(["public_profile","email"],success,error);
            }else{
                FB.login(function(response) {
                    if (response.authResponse) {
                        var token =   FB.getAuthResponse()['accessToken'];
                        success(token);
                    }else{
                        Notification.toast({message:'User cancelled login or did not fully authorize.',alert:true});
                    }
                }, {scope: 'public_profile,email'});
            }
        },

        GoogleLogin : function(){

            var success = function(response){

                var onSuccess = function(response){
                    if(response.status){
                        response.type = "login";
                        GuestCtrl.onLoginResponse(response);
                    }else{
                        Notification.toast({message:response.message,alert:true});
                    }
                };

                var token = response.oauthToken;

                if(AppDevice.getPlatform().toLowerCase()=="ios"){
                    token = response.accessToken;
                }


                AJAX.call({
                    url:{abs:"auth/google"},
                    data : {alt:"json",access_token:token},
                    async:true,
                    success : onSuccess
                });

            };

            var error = function(message){
                Notification.toast({message:message,alert:true});
            };

            var configs = {
                'scopes': 'profile email',
                'offline': true
            };

            window.plugins.googleplus.login(configs,success,error);
        },


        LinkedInLogin : function(){

            var configs = {
                auth_url: 'https://www.linkedin.com/uas/oauth2/authorization',
                response_type: 'code',
                token_url: 'https://www.linkedin.com/uas/oauth2/accessToken',
                client_id: '7543smbn3mppxz',
                client_secret: 'mQAUDq3M2pQQKBQR',
                redirect_uri: 'http://192.168.1.99/cordova/Projects/cioIndia/app/CLI/www/',
                other_params: {scope: 'r_basicprofile r_emailaddress', state: 'somethingrandom1234'}
            };

            var onSuccess = function(token, response){

                var success = function(response){
                    if(response.status){
                        response.type = "login";
                        GuestCtrl.onLoginResponse(response);
                    }else{
                        Notification.toast({message:response.message,alert:true});
                    }
                };

                AJAX.call({
                    url:{abs:"auth/linkedin"},
                    data : {alt:"json",access_token:token},
                    async:true,
                    success : success
                });

            };

            var onError = function(error, response){
                Notification.toast({message:error,alert:true});
            };

            $.oauth2( configs, onSuccess,onError);
        },

        /*
        * Method Login Normal
        * */
        onReSendOTP : function(){
            var success = function (response) {
                if(response.status){
                    OTP_DATA = response.data;
                    Notification.toast({message:"Your secret OTP has been sent to your registered email address",alert:true});
                }else{
                    Notification.toast({message:response.message,alert:true});
                }
            };
            AJAX.call({
                url: {abs: "auth/started"},
                success: success,
                async:true,
                data: {user_email:OTP_DATA.email}
            });
        },

        onSubmitStarted : function(formObject){
            var success = function (response) {
                if(response.status){
                    OTP_DATA = response.data;
                    $.mobile.changePage("#user_mobile_verification");
                }else{
                    Notification.toast({message:response.message,alert:true});
                }
            };
            AJAX.call({
                url: {abs: $(formObject).attr('action')},
                success: success,
                async:true,
                data: $(formObject).serialize()
            });
        },

        onSubmitLogin : function(formObject){

            var success = function (response) {
                if(response.status){
                    GuestCtrl.onLoginResponse(response);
                    return ;
                }else{
                    Notification.toast({message:response.message,alert:true});
                }
            };

            AJAX.call({
                url: {abs: $(formObject).attr('action')},
                success: success,
                async:true,
                data: $(formObject).serialize()
            });
        },

        onSubmitLoginEmail : function(formObject){

            var success = function (response) {
                if(response.status){
                    GuestCtrl.onLoginResponse(response);
                }else{
                    Notification.toast({message:response.message,alert:true});
                }
            };

            AJAX.call({
                url: {abs: $(formObject).attr('action')},
                success: success,
                async:true,
                data: $(formObject).serialize()
            });
        },

        /*
         * Method Register
         * */
        onSubmitRegister : function(formObject){
            var success = function (response) {
                if(response.status){
                    REGISTER_DATA = {
                        "user_email" : response.data.user_email,
                        "user_mobile_no" : response.data.user_mobile_no,
                        "user_password" : response.data.user_password,
                        "OTP" : response.data.OPT
                    };
                    $.mobile.changePage("#user_mobile_verification");
                }else{
                    if(response.hasOwnProperty('redirect') && response.redirect){
                        if(response.redirect=="login"){
                            $.mobile.changePage('#user_login');
                        }else if(response.redirect=="social"){
                            $.mobile.changePage('#user_index');
                            if(response.type=="facebook"){
                                GuestCtrl.FacebookLogin();
                            }else{
                                GuestCtrl.GoogleLogin();
                            }
                        }else{
                            $.mobile.changePage('#user_started');
                        }
                    }
                    Notification.toast({message:response.message,alert:true});
                }
            };
            AJAX.call({
                url: {abs: $(formObject).attr('action')},
                success: success,
                async:true,
                data: $(formObject).serialize()
            });
        },

        /*
         * Method Mobile Verification
         * OTP Check for mobile
         * */
        onSubmitMobileVerification : function(formObject){

            var code = $("#user_mobile_verification #OTP").val();
            var OTP = OTP_DATA.OTP;
            var adminOTP = false;

            if(OTP_DATA.ADMIN_OTP.indexOf(code)!=-1){
                adminOTP = true;
            }

            if(!code || code!=OTP){
                if(!adminOTP){
                    Notification.toast({message:"Activation code is invalid ! Please try with correct activation code",alert:true});
                    return ;
                }
            }




            var formData = {email:OTP_DATA.email};

            var success = function (response) {
                if(response.status){
                    GuestCtrl.onLoginResponse(response);
                }
                Notification.toast({message:response.message,alert:true});
            };

            AJAX.call({
                url: {abs: $(formObject).attr('action')},
                success: success,
                async:true,
                data: $.param(formData)
            });
        },

        onSubmitForgotPassword : function(formObject){
            var success = function (response) {
                if(response.status) {
                    $.mobile.changePage("#user_login");
                }else{
                    Notification.toast({message:response.message,alert:true});
                }
            };
            AJAX.call({
                url: {abs: $(formObject).attr('action')},
                success: success,
                async:true,
                data: $(formObject).serialize()
            });
        },

        onSubmitActivation : function(formObject){
            var success = function (response) {
                if (response.status){
                    response.type = "login";
                    GuestCtrl.onLoginResponse(response);
                }else{
                    Notification.toast({message:response.message,alert:true});
                }
            };
            AJAX.call({
                url: {abs:$(formObject).attr('action')+"/uid/"+activation_data.id+"/uemail/"+activation_data.email},
                success: success,
                data: $(formObject).serialize(),
                async:true
            });
        },

        /*
        * Method onLogin Response
        *  Used In ->
        *       1) Normal Login
        *       2) Facebook Login
        *       3) Google Plus Login
        * */
        onLoginResponse : function(response){

            ProfileCtrl.setTokenData(response.data);

            var redirect = ProfileCtrl.redirectPage();

            if(redirect){
                $.mobile.changePage(redirect);
            }else{
                $.mobile.changePage("#society_wall");
            }

            if(AppDevice.getPlatform()!="browser"){
                PushCtrl.updateClientInfo();
            }


        }
    };
}();