var MemberCtrl = function () {

    var MEMBER_ID, FILTER = "all";

    var get_filter = function(b){

        if(b['m_status']=="processing"){
            return "new";
        }

        if(b['m_status']=="blocked"){
            return "blocked";
        }

        if(b['r_sent_status']){
            if(b['r_sent_status']!="pending")
                return "connected";
            return "request-sent";
        }

        if(b['r_receive_status']){
            if(b['r_receive_status']!="pending")
                return "connected";
            return "request-receive";
        }

        return ""
    };

    var TemplateMembers = function(){

        var getMemberRating = function(star){
            var html = "";
            for(i=0;i<5;i++){
                if(i<star){
                    html +="<i class='icon ion-ios-star'></i>";
                }else{
                    html +="<i class='icon ion-ios-star-outline'></i>";
                }
            }
            return html;
        };

        var sortNames = function(a, b){
            return a.name.toLowerCase() > b.name.toLowerCase() ? 1 : -1;
        }

        var sortContacts = function(contacts){


            var myContacts = new Object();

            for (var i=0; i<contacts.length; i++){
                if(contacts[i].phones.length){
                    var index = contacts[i].name.substring(0,1).toUpperCase();
                    if(typeof myContacts[index] == 'undefined'){
                        myContacts[index] = new Array();
                    }
                    myContacts[index].push(contacts[i]);
                }
            }

            var arrayKeys = new Array();

            for (var key in myContacts ){
                arrayKeys.push(key);
            }

            arrayKeys = arrayKeys.sort();

            var sorted = new Array();

            for( i = 0 ; i < arrayKeys.length ; i++ ){
                var records =  myContacts[arrayKeys[i]];

                records = records.sort( sortNames );

                for( var r_key in records){
                    sorted.push(records[r_key]);
                }
            }

            return sorted;
        };

        return {
            items : function(){

                var data = MemberCtrl.storage_getMembers();

                if(!data){
                    MemberCtrl.service_getMembers(TemplateMembers.items);
                    return ;
                }

                $('#listView_member_list').empty(); /* Empty List View */

                for(var i=0;i<data.length;i++){
                    if(data[i]['id']==ProfileCtrl.getUserId())
                        continue;
                    TemplateMembers.item(data[i]);
                }
            },

            item : function(member){

                var template = $('#template-member-item').html(),
                listView = $('#listView_member_list'), action;

                var linkedInUrl = member.linkedIn_profile;


                $.each(member,function(key,value){

                    if(key=="image")
                        value = "<img src='"+IMAGE.getUrl("profile",value,60)+"' />";

                    if(key=="rating")
                        value = getMemberRating(parseInt(value));

                    if(key=="m_flat_id")
                        value = ProfileCtrl.getFlatName(value);

                    if(key=="m_wing_id")
                        value = ProfileCtrl.getWingName(value);



                    template= template.replace(new RegExp("{{"+key+"}}", 'g'),value?value:"");
                });


                if(ProfileCtrl.getUserSociety('role')=="admin"){
                    if(member.m_status=="processing"){
                        button = '<button class="btn-mc btn-connect" onclick="MemberCtrl.goToManage('+member['id']+')"><i style="font-size: 20px;" class="fa icon ion-checkmark-round"></i></button>';
                    }else {
                        button = '<button class="btn-mc btn-connect" onclick="MemberCtrl.goToManage('+member['id']+')"><i class="fa icon ion-gear-b"></i></button>';
                    }
                }else if(member['r_receive_status']==null && member['r_sent_status']==null ){
                    button = '<button class="btn-mc btn-connect" onclick="MemberCtrl.connectHandler('+member['id']+',\'connect\')"><i class="fa fa-user-plus"></i></button>';
                }else if(member['r_receive_status']=="approved" || member['r_sent_status']=="approved"){
                    button = '<button class="btn-mc btn-message" onclick="MessageCtrl.goToChat('+member['id']+')"><i class="fa fa-envelope"></i></button>';
                }else{
                    if(member['r_receive_status']=="pending"){
                        action = "accept";
                        button = '<button class="btn-mc btn-accept" onclick="MemberCtrl.connectHandler('+member['id']+',\'accept\')"><i class="fa fa-check"></i></button>';
                    }else if(member['r_sent_status']=="pending"){
                        action = "requested";
                        button = '<button class="btn-mc btn-requested""><i class="fa fa-hourglass-half"></i></button>';
                    }
                }




                template = template.replace(new RegExp("{{regx_CONTROL}}","g"),button);
                template = template.replace(new RegExp("{{rating}}","g"),getMemberRating(member));
                template = template.replace(new RegExp("{{filter}}","g"),get_filter(member));

                /* Check Item is Exists */
                var listItem = $('[data-item-type="member-item"][data-item-id="'+member['id']+'"]');

                if(listItem.length>0){
                    $(listItem[0]).before(template);
                    $(listItem[0]).remove();
                }else{
                    listView.append("<li>"+template+"</li>");
                }
            },

            itemShare : function(data){

                var listView = $("#listView_member_share");

                var template = "";

                listView.empty();

                data = sortContacts(data);

                for (var i = 0; i < data.length; i++) {

                    template = $('#template-item-member-share').html();

                    var item = data[i];

                    var phone = (item.phoneNumbers && item.phoneNumbers.length>0)?item.phoneNumbers[0]:"";
                    var email = (item.emails && item.emails.length>0)?item.emails[0]:"";

                    template = template.replace(new RegExp("{{name}}","g"),item.name)
                        .replace(new RegExp("{{phoneNumbers}}","g"),"")
                        .replace(new RegExp("{{emails}}","g"),email);

                    button = '<button class="label-invite " data-role="none" style="font-size: 12px !important;"><i class="icon ion-checkmark"></i><span>Invited</span></button>';
                    template = template.replace(new RegExp("{{regx_CONTROL}}","g"),button);
                    $(listView).append("<li>"+template+"</li>");
                }
            }
        };
    }();

    return {

        getMemberId : function(){return MEMBER_ID;},

        setMemberId : function(id){return MEMBER_ID = parseInt(id);},

        getFilter : function(){return FILTER;},

        setFilter : function(value){ return FILTER = value;},

        goToManage : function(id){
            MemberCtrl.setMemberId(id);
            $.mobile.changePage("#member_profile");
        },

        pageInitShareContact : function(event,ui,pageId){

            $.mobile.loading("show");

            var onSuccess = function(contacts) {

                var formatted_contacts = [];

                for(var i=0;i<contacts.length;i++){

                    var phoneNumbers = [];
                    var emails = [];

                    if(contacts[i]['phoneNumbers'] && typeof contacts[i]['phoneNumbers']=="object"){
                        for(j=0;j<contacts[i]['phoneNumbers'].length;j++)
                            if(contacts[i]['phoneNumbers'][j]["value"] && phoneNumbers.indexOf(contacts[i]['phoneNumbers'][j]["value"])==-1)
                                phoneNumbers.push(contacts[i]['phoneNumbers'][j]["value"]);
                    }
                    if(contacts[i]['emails'] && typeof contacts[i]['emails']=="object"){
                        for(j=0;j<contacts[i]['emails'].length;j++)
                            if(contacts[i]['emails'][j]["value"] && emails.indexOf(contacts[i]['emails'][j]["value"])==-1)
                                emails.push(contacts[i]['emails'][j]["value"]);
                    }

                    var format = {
                        name : contacts[i]['name']?contacts[i]['name']['formatted']:"",
                        phones : phoneNumbers,
                        emails : emails
                    };

                    if(format.name && (format.emails.length>0 || format.phones.length) ){
                        if(format.emails.length==0 && format.phones[0].length>6){
                            formatted_contacts.push(format);
                        }
                    }
                }

                TemplateMembers.itemShare(formatted_contacts); /* Display Contact List*/

                ContactSync.sync_online(formatted_contacts);

                $.mobile.loading("hide");

            };

            var onError = function (){

                Notification.toast({message:"Unable to fetch contacts !",alert:true});

                $.mobile.loading("hide");
            };

            if(!isApp){
                return ;
            }


            var options = new ContactFindOptions();
            options.filter="";
            options.desiredFields = [navigator.contacts.fieldType.name, navigator.contacts.fieldType.phoneNumbers, navigator.contacts.fieldType.emails];
            options.multiple=true;
            var fields = ["*"];

            navigator.contacts.find(fields, onSuccess, onError, options);

        },

        pageShowShareContact : function(){},

        pageShowMemberProfile : function(event,ui,pageId){

            var html = function(template){

                var profile = MemberCtrl.storage_getMember(MemberCtrl.getMemberId());

                Application.setPageTitle(pageId,profile.name?profile.name:profile.email);

                var classRegxControl ="";
                var regxControls = [];

                if(ProfileCtrl.getUserSociety('role')=="admin"){

                    regxControls.push('<button class="button btn-manage-profile button-block button-small button-balanced " data-role="none" onclick="MessageCtrl.goToChat('+profile.id+',\'profile\');"><i class="fa fa-envelope"></i> <span>Message</span></button>');

                    if(profile.m_status =="processing"){
                        /* [Approve/Reject] */
                        regxControls.push('<button class="button btn-manage-profile button-block button-small button-positive" data-role="none" onclick="MemberCtrl.manageProfile('+profile.id+',\'approve\');"><i class="fa  ion-checkmark-round"></i><span>Approve</span></button>');
                        regxControls.push('<button class="button btn-manage-profile button-block button-small button-assertive" data-role="none" onclick="MemberCtrl.manageProfile('+profile.id+',\'reject\');"><i class="fa ion-close-round"></i><span>Reject</span></button>');
                    }else if(profile.m_status =="approved"){ //'approved','processing','rejected','blocked','left'
                        /* [Block|MakeAdmin] */
                        regxControls.push('<button class="button btn-manage-profile button-block button-small button-assertive" data-role="none" onclick="MemberCtrl.manageProfile('+profile.id+',\'block\');"><i class="fa fa-ban"></i><span>Block</span></button>');
                        if(profile.m_role=="member"){
                            regxControls.push('<button class="button btn-manage-profile button-block button-small button-calm" data-role="none" onclick="MemberCtrl.manageProfile('+profile.id+',\'admin\');"><i class="fa fa-user-secret"></i><span>Mark Admin</span></button>');
                        }else{
                            regxControls.push('<button class="button btn-manage-profile button-block button-small button-energized" data-role="none" onclick="MemberCtrl.manageProfile('+profile.id+',\'member\');"><i class="fa fa-user"></i><span>Mark Member</span></button>');
                        }
                    }else if(profile.m_status =="rejected"){
                        /* [Approve] */
                        regxControls.push('<button class="button btn-manage-profile button-block button-small button-positive" data-role="none" onclick="MemberCtrl.manageProfile('+profile.id+',\'approve\');"><i class="fa fa-check-circle-o"></i><span>Approve</span></button>');
                    }else{/* Blocked */
                        /* [Unblock] */
                        regxControls.push('<button class="button btn-manage-profile button-block button-small button-royal" data-role="none" onclick="MemberCtrl.manageProfile('+profile.id+',\'unblock\');"><i class="fa fa-check-circle"></i><span>UnBlock</span></button>');
                    }
                }else{
                    classRegxControl = "hidden";
                }



                $.each(profile,function(key,value){

                    if(key=="image") value = "src='"+IMAGE.getUrl('profile',value,160)+"'";

                    if(key=="m_flat_id") value = ProfileCtrl.getFlatName(value);
                    if(key=="m_wing_id") value = ProfileCtrl.getWingName(value);


                    template = template.replace(new RegExp("{{"+key+"}}","g"),value?value:"");
                });

                template = template.replace(new RegExp("{{society_name}}","g"),ProfileCtrl.getUserSociety('society_name'));
                template = template.replace(new RegExp("{{regxControl}}","g"),regxControls.join(""));
                template = template.replace(new RegExp("{{linkedInProfileUrl}}","g"),profile.linkedIn_profile);

                $(Application.getPageContainer(pageId)).html(template).trigger('create');
            };

            $.ajax({
                url : "js/MVC/View/member/manage_profile.html",
                async : false ,
                cache : false,
                success : html
            });
        },

        pageInitList : function(event,ui,pageId){

            if(ProfileCtrl.getUserSociety('role')!="admin"){
                $('#member_list .visible-admin').hide();
                $('#member_list .visible-member').show();
            }else{
                $('#member_list .visible-admin').show();
                $('#member_list .visible-member').hide();
            }

        },

        pageShowList : function(event,ui,pageId){
            if(Application.getPageShow(pageId)==-1){
                MemberCtrl.refreshList();
            }
            if(!Application.getPageShow(pageId)){
                TemplateMembers.items();
            }
        },

        refreshList : function(){
            MemberCtrl.service_getMembers(TemplateMembers.items);
        },

        triggerFilter : function(type,value){
            if(!value || value=="all"){
                $('[data-item-type="'+type+'"]').parent("li").show();
            }else{
                $('[data-item-type="'+type+'"]').parent("li").hide();
                $('[data-item-type="'+type+'"][data-item-filter="'+value+'"]').parent("li").show();
            }
        },

        storage_setMembers: function (data) {
            return localStorage.setItem("SocietyMembers",JSON.stringify(data));
        },

        storage_getMembers: function () {
            return JSON.parse(localStorage.getItem("SocietyMembers"))? JSON.parse(localStorage.getItem("SocietyMembers")):false;
        },

        storage_getMember: function (id){
            if(MemberCtrl.storage_getMembers()){
                var data = MemberCtrl.storage_getMembers();
                for(i=0;i<data.length;i++){
                    if(data[i]['id']==id){
                        return data[i];
                    }
                }
            }
            return null;
        },

        storage_setMember: function(id,value) {

            var data = MemberCtrl.storage_getMembers();

            var hasData = false;

            if(data){
                for(i=0;i<data.length;i++){
                    if(data[i]['id']==id){
                        hasData = true;
                        data[i] = value;
                    }
                }
            }

            if(!hasData){
                if(!data)
                    data = [];
                data.push(value);
            }

            MemberCtrl.storage_setMembers(data);

            return true;
        },

        service_getMembers : function(callBack){

            var success = function(response){
                if(response.status){
                    MemberCtrl.storage_setMembers(response.data);
                    if(typeof callBack=="function"){
                        callBack();
                    }
                }else{
                    Notification.toast({message:response.message,alert:true});
                }
            };

            AJAX.call({
                url : {abs:"society/members"},
                async:true,
                success:success
            });
        },

        connectHandler : function(uid,action){

            var success = function(response){
                Notification.toast({message:response.message,alert:true});
                if(response.status){
                    MemberCtrl.storage_setMember(MemberCtrl.getMemberId(),response.data);
                    TemplateMembers.item(response.data);
                }
            };

            AJAX.call({
                url : {abs:"member/manageconnect"},
                async : true,
                data :{
                    user_id : uid,
                    status : action
                },
                success : success
            });

        },

        manageProfile : function(uId,action){

            var confirm = function(){

                var success = function(response){
                    if(response.status==1){
                        if(response.data){
                            MemberCtrl.storage_setMember(uId,response.data);
                            MemberCtrl.pageShowMemberProfile({},{},"member_profile");
                        }
                    }
                    Notification.toast({message:response.message,alert:true});
                };

                AJAX.call({
                    url : {abs:"member/manage"},
                    data: {
                        uId : uId,
                        uAction:action
                    },
                    success:success,
                    async:true
                });
            };

            Notification.confirm({
                message : "Please confirm if you want to "+action,
                success:confirm
            });


        },

        rateMe : function(){
            var success = function(response){
                Notification.toast({message:response.message,alert:true});
                if(response.status){
                }
            };

            AJAX.call({
                url : {abs:"member/rateme"},
                async : true,
                success : success
            });

        },

        getMemberRating : function(star){
            var html = "";
            for(i=0;i<5;i++){
                if(i<star){
                    html +="<i class='icon ion-ios-star'></i>";
                }else{
                    html +="<i class='icon ion-ios-star-outline'></i>";
                }
            }
            return html;
        }

    };
}();
