var NearByCtrl = function () {

    var map = false, map_direction = false, PLACE_ID = false ,PLACE_TYPE = "restaurant";

    var GoogleConfigs = {
        "atm": {"type": ["atm"], "radius": "3000"},
        "pharmacy": {"type": ["pharmacy"], "radius": "3000"},
        "mall": {"type": ["mall"], "radius": "3000"},
        "restaurant": {"type": ["restaurant"], "radius": "3000"},
        "hospital": {"type": ["hospital"], "radius": "3000"},
        "school": {"type": ["school"], "radius": "3000"},
        "department_store": {"type": ["department_store"], "radius": "5000"},//"pharmacy"
        "local_government_office": {"type": ["local_government_office"], "radius": "3000"},
        "movie_theater": {"type": ["movie_theater"], "radius": "3000"},
        "park": {"type": ["park"], "radius": "3000"},
        "transport": {"type": ["airport", "bus_station", "train_station"], "radius": "10000"}
    };

    var TemplatePlaces = function(){
        return {

            items : function(){

                var places = NearByCtrl.storage_getPlaces();

                var container = $('#listView_nearby_' + NearByCtrl.getPlaceType());

                container.empty();

                for (var i = 0, place; place = places[i]; i++){
                    container.append(TemplatePlaces.item(place));
                }
            },

            item : function(place){

                var template = $('#template-nearby-location-block').html();

                template = template.replace(new RegExp("{{id}}","g"),place.id)
                    .replace(new RegExp("{{icon}}","g"),"src='"+place.icon+"'")
                    .replace(new RegExp("{{rating}}","g"),TemplatePlaces.showRating(place.rating))
                    .replace(new RegExp("{{name}}","g"),place.name)
                    .replace(new RegExp("{{address}}","g"),place.address);

                 return template;
            },

            showRating : function(star){
                var html = "";
                for(i=0;i<parseInt(star);i++){
                    html +="<i class='icon ion-ios-star'></i>";
                }
                return html;
            }
        }
    }();

    var TemplateNews = function(){
        return {
            items : function(){

                var data = STORAGE.getNews();


                if(!data){
                    NearByCtrl.refreshNews();
                    return ;
                }

                var listView = $(".list.news");

                listView.empty();



                for(i=0;i<data.length;i++){
                    var item = data[i];
                    var template = $('#template-news-block').html()
                        .replace(new RegExp("{{src}}","g"),item.src)
                        .replace(new RegExp("{{title}}","g"),item.title)
                        .replace(new RegExp("{{link}}","g"),item.link)
                        .replace(new RegExp("{{description}}","g"),item.description);
                    listView.append("<li>"+template+"</li>");
                }
            }
        }
    }();

    return {

        getPlaceType: function () {
            return PLACE_TYPE
        },

        setPlaceType: function (val) {
            return PLACE_TYPE = val;
        },

        getPlaceId: function () {return PLACE_ID},

        setPlaceId: function (val) {return PLACE_ID = val;},

        getOrigin: function (){
            var data = ProfileCtrl.getUserSociety();
            return {
                latitude:data.lat,
                longitude:data.lng,
                place : data.google
            };
        },

        goToPlace : function(id){
            NearByCtrl.setPlaceId(id);
            $.mobile.changePage("#nearby_direction");
        },

        /*
        * Method Page Show New By Places
        * */
        pageShowPlaces : function(event,ui,pageId){

            NearByCtrl.setPlaceType(pageId.replace('nearby_', ""));

            if(!Application.getPageShow(pageId)){
                if(NearByCtrl.storage_getPlaces()){
                    TemplatePlaces.items();
                }else{
                    NearByCtrl.refreshPlaces();
                }
            }
        },

        /*
        * Method Refresh Places
        * */
        refreshPlaces : function(){

            $.mobile.loading('show');

            var origin = NearByCtrl.getOrigin();

            if(!map){
                map = new google.maps.Map(document.getElementById('map-canvas-nearby-places'), {
                    center: new google.maps.LatLng(origin.latitude, origin.longitude),
                    zoom: 15,
                });
            }

            var service = new google.maps.places.PlacesService(map);

            var request = {
                location: map.getCenter(),
                //radius: GoogleConfigs[NearByCtrl.getPlaceType()]["radius"],
                types: GoogleConfigs[NearByCtrl.getPlaceType()]["type"],
                rankBy: google.maps.places.RankBy.DISTANCE,
            };

            service.nearbySearch(request, function (results, status) {
                if(status != google.maps.places.PlacesServiceStatus.OK){
                    $.mobile.loading('hide');
                    return;
                }

                var collector = [];

                for(var i=0;i<results.length;i++){
                    var item = results[i];
                    var place = {
                        id : item.id,
                        name : item.name,
                        icon: item.icon,
                        rating : item.hasOwnProperty('rating')?item.rating:0,
                        address : item.vicinity,
                        type : item.types,
                        geometry : {
                            lat : item.geometry.location.lat(),
                            lng : item.geometry.location.lng()
                        }
                    };
                    collector.push(place);
                }

                NearByCtrl.storage_setPlaces(collector);

                TemplatePlaces.items();

                $.mobile.loading('hide');

            });
        },

        /*
        * Method PageShow Direction
        * */
        pageShowDirection: function (event, ui, pageId){

            $.mobile.loading('show');

            var place = NearByCtrl.storage_getPlace(NearByCtrl.getPlaceId());

            var origin = NearByCtrl.getOrigin();

            Application.setPageTitle(pageId,place.name);

            var template = $('#template-nearby-direction').html().replace(new RegExp("{{name}}","g"),place.name)
                .replace(new RegExp("{{address}}","g"),place.address)
                .replace(new RegExp("{{rating}}","g"),TemplatePlaces.showRating(place.rating));

            $('#nearby_direction .data-content-working').html(template);



            map_direction = new google.maps.Map(document.getElementById('map-canvas-direction'),{
                center: new google.maps.LatLng(origin.latitude, origin.longitude),
                zoom:16
            });

            var directionsService = new google.maps.DirectionsService();

            var request = {
                origin: new google.maps.LatLng(origin.latitude, origin.longitude),
                destination: new google.maps.LatLng(place.geometry.lat,place.geometry.lng),
                travelMode: google.maps.DirectionsTravelMode.DRIVING,
            };

            directionsService.route(request, function (response, status) {
                if (status == google.maps.DirectionsStatus.OK) {
                    var directionsDisplay = new google.maps.DirectionsRenderer();
                        directionsDisplay.setPanel(document.getElementById('map-direction-panel'));
                        directionsDisplay.setMap(map_direction);
                        directionsDisplay.setDirections(response);
                        setTimeout(function(){$('.nearby-direction-place').append("<p class='time-distance-summary remove-pageHide'>"+$('.adp-summary').html()+"</p>");},100);
                }
                $.mobile.loading('hide');
            });

        },

        /*  STORAGE */
        storage_getPlaces : function(){

            var stored_places = JSON.parse(localStorage.getItem('NEAR_BY_PLACES'));

            if(!stored_places)
                stored_places = {};

            if(stored_places.hasOwnProperty(NearByCtrl.getPlaceType())){
                return stored_places[NearByCtrl.getPlaceType()];
            }
            return false;
        },

        storage_setPlaces : function(items){
            var stored_places = JSON.parse(localStorage.getItem('NEAR_BY_PLACES'));
            if(!stored_places)
                stored_places = {};
            stored_places[NearByCtrl.getPlaceType()] = items;
            return localStorage.setItem('NEAR_BY_PLACES',JSON.stringify(stored_places));
        },

        storage_getPlace : function(id){
            var items = NearByCtrl.storage_getPlaces();
            for(var i=0; i<items.length;i++)
                if(items[i]['id']==id)
                    return items[i];
            return false;
        },

        /* NEWS */
        pageShowNews : function(event,ui,pageId){
            if(!Application.getPageShow(pageId))
                TemplateNews.items();
        },

        refreshNews : function(){

            var topic = ProfileCtrl.getUserSociety('society_keywords');

            var feedUrl =  "https://news.google.com/news/feeds?pz=1&cf=all&ned=uk&hl=en&q="+topic+"&output=rss";
            var newsUrl = "http://ajax.googleapis.com/ajax/services/feed/load?v=1.0&num=20&callback=?&q="+encodeURIComponent(feedUrl);

            $.ajax({
                url : newsUrl,
                dataType : 'jsonp',
                success  : function (data) {
                    vs_debugger = data;
                    var allItem = [];
                    if(data.responseData &&data.responseData.feed && data.responseData.feed.entries){
                        $.each(data.responseData.feed.entries, function (i,e){
                            var link = e.link.split("&url=");
                            var regex = /<img.*?src="(.*?)"/;
                            var src = regex.exec(e.content);
                            if(src){src = src[1];}else{src="img/default/default.png"}
                            allItem.push({
                                src : src,
                                title: e.title,
                                link : link[1],
                                description: e.contentSnippet
                            });
                        });
                    }else{
                        Notification.toast({message:data.responseDetails,alert:true});
                    }
                    STORAGE.setNews(allItem);
                    TemplateNews.items();
                }
            });
        },

    };

}();

