var ProfileCtrl = function(){

    /*
    * Mapping
    * */
    var MAP,GEOCODE = false ,SOCIETY_ID = false, STR_TYPE = false, WINGS = false,  FLATS = false,  COORDINATES = { latitude:19.1702821,longitude:72.86989459999995};

    /*
    * Profile
    * */
    var tokenData, NotificationInterval = 1000*30, SOCIETY_STRUCTURE = false;


    var TemplateProfile = function(){
        return {

            items : function(){

                var places = ProfileCtrl.getNearByPlaces();

                var container = $('#listView_profile_address');

                container.empty();

                for (var i = 0, place; place = places[i]; i++){
                    var template = $('#template-profile-address-near').html();
                    template = template.replace(new RegExp("{{id}}","g"),place.id)
                        .replace(new RegExp("{{src}}","g"),"src='"+place.icon+"'")
                        .replace(new RegExp("{{rating}}","g"),place.rating)
                        .replace(new RegExp("{{lat}}","g"),place.geometry.lat)
                        .replace(new RegExp("{{lng}}","g"),place.geometry.lng)
                        .replace(new RegExp("{{name}}","g"),place.name)
                        .replace(new RegExp("{{address}}","g"),place.address);
                    container.append("<li>"+template+"</li>");
                }
            },

            points : function(){

                var data = ProfileCtrl.storage_getPoints();

                if(!data){
                    ProfileCtrl.service_getPoints(TemplateProfile.points);
                    return ;
                }

                var template = $('#template-profile-point-item').html();

                var listview = $('#listview_profile_points');

                listview.empty();

                var total_points = 0;

                $.each(data,function(a,b){
                    var copy = template;
                    $.each(b,function(c,d){
                        if(c=="upoint_for"){
                            switch(d){
                                case "addreview":d="Advertisement Review";break;
                                case "shopping":d="SoSmart Shopping";break;
                                case "referral":d="Referral";break;
                            }
                        }
                        copy= copy.replace(new RegExp("{{"+c+"}}", 'g'),d);
                    });
                    if(b['upoint_type']=="in"){
                        total_points += parseInt(b['upoint_point']);
                        copy= copy.replace(new RegExp("{{icon}}", 'g'),"ion-plus-circled");
                    }else{
                        total_points -= parseInt(b['upoint_point']);
                        copy= copy.replace(new RegExp("{{icon}}", 'g'),"ion-minus-circled");
                    }

                    listview.append("<li>"+copy+"</li>");
                });

                $(".user-point-summary span").html(total_points);


            },

            societies : function(){

                var template = $('#template-mapsociety-list-item').html();

                var data = ProfileCtrl.storage_getSocieties();

                var listView = $('#listView_profile_address');

                listView.empty();

                $.each(data,function(a,b){
                    var copy = template;
                    $.each(b,function(c,d){
                        if(c=="image"){d = "<img src='img/default/googlemap.png' data-src='"+img_get({"type":"society","name":d})+"' />";}
                        copy= copy.replace(new RegExp("{{"+c+"}}", 'g'),d);
                    });
                    listView.append("<li>"+copy+"</li>");
                });

            }
        }
    }();

    return {

        getOTP : function(){return MobileOTP;},
        setOTP : function(value){return MobileOTP=value;},

        getNearByPlaces : function(){return NEAR_BY_PLACES;},
        setNearByPlaces : function(value){return NEAR_BY_PLACES = value;},

        setMapSocietyId : function(value){ return SOCIETY_ID = parseInt(value);},
        getMapSocietyId : function(){return SOCIETY_ID;},

        getSocietyWings : function(){return WINGS;},
        setSocietyWings : function(data){return WINGS = data;},

        getSocietyFlats : function(wing){
            if(typeof FLATS=="object" && FLATS.hasOwnProperty(wing)){
                return FLATS[wing];
            }
            return {};
        },
        setSocietyFlats : function(data){return FLATS = data;},

        getStrType: function (){return STR_TYPE;},
        setStrType: function (value) {return STR_TYPE = value;},

        redirectPage : function(){

            var u_profile = ProfileCtrl.getUserProfile();

            var u_mapping = ProfileCtrl.getUserSociety();

            var redirect = false;

            if(!u_profile.user_name || !u_profile.user_image || !u_profile.user_mobile_no){
                return "#profile_information";
            }

            if(u_mapping.mapping_status=="approved"){
                return "#society_wall";
            }

            if(u_mapping.mapping_status=="processing" || u_mapping.mapping_status=="blocked"){
                return "#profile_approval";
            }

            return "#profile_address";

        },

        init:function(){
            ProfileCtrl.loadTokenData();
            setInterval(function(){ProfileCtrl.syncServer();},NotificationInterval);
        },

        pageShowProfileVerification : function(event,ui,pageId){

            var template = $('#template-pending-verification').html();

            var admin = ProfileCtrl.getUserSociety('admin');

            $.each(admin,function(key,value){
                if(key=="user_image") value = "src='"+IMAGE.getUrl('profile',value,160)+"'";
                template = template.replace(new RegExp("{{"+key+"}}","g"),value);
            });
            $(Application.getPageContainer(pageId)).html(template).trigger('create');

        },

        /* Society Mapping Related Methods */
        pageInitProfileAddress : function(event,ui,pageId){},

        pageShowProfileAddress : function(event, ui,pageId){

            if(ProfileCtrl.getUserProfile('latitude') && ProfileCtrl.getUserProfile('longitude')){
                COORDINATES = {latitude:ProfileCtrl.getUserProfile('latitude'),longitude:ProfileCtrl.getUserProfile('longitude')};
            }

            /* Populate  */
            $("#profile_address #user_google_location").val(ProfileCtrl.getUserProfile('address')?ProfileCtrl.getUserProfile('address'):"");
            $("#profile_address #user_latitude").val(ProfileCtrl.getUserProfile('latitude')?ProfileCtrl.getUserProfile('latitude'):"");
            $("#profile_address #user_longitude").val(ProfileCtrl.getUserProfile('longitude')?ProfileCtrl.getUserProfile('longitude'):"");

            if(!Application.getPageShow(pageId)){
                ProfileCtrl.refreshProfileAddress();
            }
        },

        refreshProfileAddress : function(){

            GEOCODE = new google.maps.Geocoder();

            var latLng = new google.maps.LatLng(COORDINATES.latitude, COORDINATES.longitude);

            map = new google.maps.Map(document.getElementsByClassName('map-canvas-profile-address')[0],{
                center:latLng,
                zoom: 16,
                draggableCursor: false,/*draggable: false,*/
                disableDefaultUI: true,
                zoomControl: true
            });

            marker = new google.maps.Marker({
                position: latLng,
                map: map,
                draggable:true,
                title: 'Current Location!'
            });



            google.maps.event.addListener(marker, 'dragend', function (event) {
                map.setCenter(marker.getPosition());
                COORDINATES.latitude = marker.getPosition().lat();
                COORDINATES.longitude = marker.getPosition().lng();
                ProfileCtrl.populateAddress();
                ProfileCtrl.service_getSocieties();
            });


            var AutoComplete = new google.maps.places.Autocomplete(document.getElementById('user_google_location'), {types: [], componentRestrictions: {country: "in"}});

            google.maps.event.addListener(AutoComplete, 'place_changed', function () {
                var place = AutoComplete.getPlace();
                var LatLng= new google.maps.LatLng(place.geometry.location.lat(), place.geometry.location.lng());
                map.setCenter(LatLng);
                map.setZoom(16);
                marker.setPosition(LatLng);
                COORDINATES.latitude =  place.geometry.location.lat();
                COORDINATES.longitude = place.geometry.location.lng();
                ProfileCtrl.populateAddress();
                ProfileCtrl.service_getSocieties();
            });

            ///ProfileCtrl.service_getSocieties();
        },

        populateAddress : function () {
            var inputLat = $("#profile_address [name='user_latitude']"),
                inputLng = $("#profile_address [name='user_longitude']");
            inputLat.val(COORDINATES.latitude);
            inputLng.val(COORDINATES.longitude);
        },

        clearAddressInput : function(){
            $('#frm_profile_address')[0].reset();
        },

        onChangeWing : function(element){
            var wing = element.value;

            var options = $("#ums_flat_id");

            options.empty();

            options.append($("<option />").val("").text("- Select -"));

            $.each(ProfileCtrl.getSocietyFlats(wing), function(a,b) {
                options.append($("<option />").val(a).text(b));
            });

            options.selectmenu("refresh", true);
        },

        goToFlatMapping : function(id){

            ProfileCtrl.setMapSocietyId(id);

            var success_data = function(response){
                if(response.status){
                    ProfileCtrl.storage_setSociety(ProfileCtrl.getMapSocietyId(),response.data);
                    $.mobile.changePage('#profile_flat_mapping');
                }else{
                    Notification.toast({message:response.message,alert:true});
                }
            };

            AJAX.call({
                url : {abs:"society/getstructure/id/"+ProfileCtrl.getMapSocietyId()},
                success:success_data,
                aysnc:true
            });
        },

        pageShowFlatMapping : function(){

            var str = ProfileCtrl.storage_getSociety(ProfileCtrl.getMapSocietyId());

            var wings = {};
            var floor = {};
            var flats = {};

            $.each(str,function(a,b){
                var index = a.split("!**!**!");
                wings[index[0]] = index[1];
                flats[index[0]] = b;
            });

            ProfileCtrl.setSocietyWings(wings);
            ProfileCtrl.setSocietyFlats(flats);

            var select_ownership = $("#ums_ownership");
            var select_wing = $("#ums_wing_id");
            var select_flat = $("#ums_flat_id");

            select_wing.empty();
            select_flat.empty();
            select_flat.append($("<option />").val("").text("- Select -"))

            select_ownership.selectmenu('refresh',true);
            select_wing.selectmenu('refresh',true);
            select_flat.selectmenu('refresh',true);

            select_wing.append($("<option />").val("").text("- Select -"));

            $.each(ProfileCtrl.getSocietyWings(), function(a,b) {
                select_wing.append($("<option />").val(a).text(b));
            });

            select_wing.selectmenu();
            select_wing.selectmenu("refresh", true);

        },

        onSubmitMapToFlat : function(inObject){

            var $form = $(inObject);

            var success = function(response){
                if(response.status) {
                    Notification.toast({message:response.message});
                    ProfileCtrl.setTokenData(response.data);
                    $.mobile.changePage('#society_wall');
                }else{
                    Notification.toast({message:response.message,alert:true});
                }
            };

            AJAX.call({
                url:{abs:"society/map/sid/"+ProfileCtrl.getMapSocietyId()},
                data: $form.serialize(),
                success:success,
                async:true
            });

        },

        service_getSocieties : function(callBack){
            var success = function(response){
                if(response.status){
                    ProfileCtrl.storage_setSocieties(response.data);
                    TemplateProfile.societies();
                }
            };
            AJAX.call({
                url : {abs:"society/list"},
                data : COORDINATES,
                success:success,
                async:true
            });
        },
        service_getSociety : function(){
            var success = function(response){
                if(response.status){
                    ProfileCtrl.storage_setSociety(response.data);
                    TemplateProfile.society();
                }
            };
            AJAX.call({
                url : {abs:"society/getstructure/id/"+ProfileCtrl.getMapSocietyId()},
                success:success,
                async:true
            });
        },

        storage_setSocieties : function(data){return  localStorage.setItem("SOCIETY_LIST",JSON.stringify(data));},
        storage_getSocieties : function(){return  JSON.parse(localStorage.getItem("SOCIETY_LIST"));},

        storage_setSociety : function(id,data){
            var stored_data = JSON.parse(localStorage.getItem("SOCIETY_STR"));

            if(!stored_data){
                stored_data = {};
            }
            stored_data[id] = data;
            return  localStorage.setItem("SOCIETY_STR",JSON.stringify(stored_data));
        },
        storage_getSociety : function(id){
            var data = JSON.parse(localStorage.getItem("SOCIETY_STR"));
            if(!data || !data.hasOwnProperty(id))
                return false;
            return data[id];
        },




        /* Profile Related Methods */

        syncServer : function(){


            if(!ProfileCtrl.getUserId()|| !ProfileCtrl.getSocietyId() ){
                return false;
            }

            var success = function(response){

                var data = response.data;

                if(data.hasOwnProperty('tokenData') && data.tokenData){
                    ProfileCtrl.setTokenData(data.tokenData);
                }

                var badge_string = '<span class=" badge-icon-header badge-messaeg-unread"></span>';
                var badge_string_message = '<span class=" badge-messaeg-header badge-messaeg-unread"></span>';

                $('.header .row-2 .ion-ios-clock').html(data['wall']?badge_string:""); /* Wall */
                $('.header .row-2 .ion-ios-people').html(data['groups']?badge_string:""); /* Groups */
                $('.header .row-2 .ion-android-contacts').html(data['members']?badge_string:""); /* Members */
                $('.header .row-1 .fa-envelope').html(data['message']?badge_string_message:"");

                if(data['message']){
                    Application.setPageShow("message_list",-1);
                }
            };

            AJAX.call({
                url: {abs: "profile/syncprofile"},
                success: success,
                beforeSend : function(){},
                data : {
                    last_updated:{
                        profile : ProfileCtrl.getUserProfile('user_updated')
                    }
                },
                async:true
            });
        },

        pageShowProfileHome : function(event,ui,pageId){
            if(!Application.getPageShow(pageId)){
                ProfileCtrl.refreshProfileHome();
            }
        },

        refreshProfileHome : function(){

            var pageId = "profile_home";

            var html = function(template){

                var profile = ProfileCtrl.getProfile();

                Application.setPageTitle(pageId,profile.user_name);

                $.each(profile,function(key,value){
                    template = template.replace(new RegExp("{{"+key+"}}"),value?value:"-");
                });

                var society = ProfileCtrl.getUserSociety();

                $.each(society,function(key,value){
                    template = template.replace(new RegExp("{{"+key+"}}"),value?value:"-");
                });


                $(Application.getPageContainer(pageId)).html(template).trigger('create');

                ProfileCtrl.myImages();

            };

            $.ajax({
                url : "js/MVC/View/profile/home.html",
                async : false ,
                cache : false,
                success : html
            });
        },

        pageShowProfilePoints : function(event,ui,pageId){
            if(Application.getPageShow(pageId)==-1){
                ProfileCtrl.refreshPagePoints();
            }
            if(!Application.getPageShow(pageId)){
                TemplateProfile.points();
            }
        },

        refreshPagePoints : function(){
            ProfileCtrl.service_getPoints(TemplateProfile.points);
        },

        service_getPoints: function (callBack) {
            var success = function (response) {
                if (response.status) {
                    ProfileCtrl.storage_setPoints(response.data);
                    if (typeof callBack == "function") {
                        callBack();
                    }
                }
            };
            AJAX.call({
                url: {abs: "profile/getpoints"},
                async: true,
                success: success
            });
        },

        storage_getPoints : function(){
            return JSON.parse(localStorage.getItem("PROFILE_POINTS"))? JSON.parse(localStorage.getItem("PROFILE_POINTS")):false;
        },

        storage_setPoints : function(data){
            return localStorage.setItem("PROFILE_POINTS",JSON.stringify(data));
        },

        onSubmitProfilePassword : function(inObject){

            var $form = $(inObject);

            var success = function(response){
                if(response.status){
                    Notification.toast({message:response.message});
                    Application.back();
                }else{
                    Notification.toast({message:response.message,alert:true});
                }
            };

            AJAX.call({
                url:{abs:$form.attr('action')},
                data: $form.serialize(),
                async:true,
                success:success
            });
        },

        resetGEOLocation : function(){

            $.mobile.loading("show");

            var onSuccess = function(response){
                $.mobile.loading("hide");
                var latlng = new google.maps.LatLng(response.latitude, response.longitude);
                map.setZoom(14);
                map.setCenter(latlng);
                marker.setPosition(latlng);
            };

            var onError = function(msg){
                $.mobile.loading("hide");
                Notification.toast({message:msg,alert:true});
            };

            GOOGLE.getGeoLocation({
                success :onSuccess,
                error : onError
            });
        },

        pageShowProfileInformation : function(){
            var profile = ProfileCtrl.getUserProfile();
            $('#profile_information #user_name').val(profile.user_name);
            $('#profile_information #user_gender').val(profile.user_gender);
            $('#profile_information #user_gender').selectmenu('refresh', true);
            $('#profile_information #user_mobile_no').val(profile.user_mobile_no);
            $('#profile_information #user_dob').val(profile.user_dob);
            $('#profile_information #user_blood_group').val(profile.user_blood_group);
            $('#profile_information #user_blood_group').selectmenu('refresh', true);
            if(ProfileCtrl.getUserProfile('user_terms')!="0"){
                $('.profileShowTerms').hide();
            }
        },

        onSubmitProfileInformation : function(inObject){
            var success = function (response) {
                if (response.status){
                    ProfileCtrl.setTokenData(response.data);
                    Notification.toast({message:"Profile Information Successfully Updated",alert:true});
                    var redirectPage = ProfileCtrl.redirectPage();
                    if(redirectPage){
                        $.mobile.changePage(redirectPage);
                    }else{
                        Application.setPageShow("profile_home",0);
                        $.mobile.changePage("#society_wall");
                    }
                }else{
                    Notification.toast({message:response.message,alert:true});
                }
            };
            AJAX.call({
                url: {abs:$(inObject).attr('action')},
                success: success,
                data: $(inObject).serialize(),
                async:true
            });

        },

        getMemberRating : function(rating){

            var html = "";

            var star = (rating) ?parseInt(rating):0;

            for(i=0;i<5;i++){
                if(i<star){
                    html +="<i class='icon ion-ios-star'></i>";
                }else{
                    html +="<i class='icon ion-ios-star-outline'></i>";
                }
            }
            return html;
        },

        myImages : function(){

            $('img[data-me="true"]').attr("src",IMAGE.getUrl("profile",ProfileCtrl.getUserProfile('user_image')));
            $('img[data-me="true"][data-size="thumb"]').attr("src",IMAGE.getUrl("profile",ProfileCtrl.getUserProfile('user_image'),"thumb"));
            $('img[data-me="true"][data-size="300"]').attr("src",IMAGE.getUrl("profile",ProfileCtrl.getUserProfile('user_image'),"300"));
            $('img[data-me="true"][data-size="160"]').attr("src",IMAGE.getUrl("profile",ProfileCtrl.getUserProfile('user_image'),"160"));

            /* Logged User Name */
            $('span[data-my-name="true"]').html(ProfileCtrl.getUserProfile('user_name'));




            $('.rating-logged-user').html(ProfileCtrl.getMemberRating(ProfileCtrl.getUserProfile("user_society_rating")));

            html_fill = "<i class='icon ion-android-star'></i>";
            html = "<i class='icon ion-android-star-outline'></i>";

        },

        getProfile : function(){
            if(tokenData){
                return tokenData.profile;
            }
            return false;
        },

        getToken : function(){
            if(tokenData){
                return tokenData.token;
            }
            return false;
        },

        getUserId : function(){
            if(tokenData){
                return tokenData.profile.user_id ? parseInt(tokenData.profile.user_id) : false;
            }
            return false
        },

        getUserProfile : function(index){
            if(tokenData){
                if(tokenData.hasOwnProperty('profile')){
                    if(typeof index=="string"){
                        if(tokenData['profile'].hasOwnProperty(index))
                            return tokenData['profile'][index];
                    }else{
                        return tokenData.profile;
                    }
                }
            }
            return false
        },

        getSocietyId : function(){
            if(tokenData){
                if(tokenData.mapping){
                    return parseInt(tokenData.mapping.society_id);
                }
            }
            return false;
        },

        getUserSociety : function(index){
            if(tokenData){
                if(tokenData['mapping']){
                    if(typeof index=="string"){
                        if(tokenData['mapping'].hasOwnProperty(index))
                            return tokenData['mapping'][index];
                    }else{
                        return tokenData['mapping'];
                    }
                }
            }
            return false
        },

        loadTokenData : function(){
            tokenData = STORAGE.getTokenData();
            var str = STORAGE.getSocietyStructure();

            var strOut = {
                wings : {},
                flats : {},
            };

            if(str){
                for(var i= 0,flat;flat=str[i];i++){
                    strOut.wings[flat['wid']] = flat['wname'];
                    strOut.flats[flat['fid']] = flat['fname'];
                }
            }

            SOCIETY_STRUCTURE = strOut;
        },

        setTokenData : function(data){

            var oldTokenData = tokenData;

            tokenData = {
                token : data.profile.uat_string,
                profile : data.profile,
                mapping : data.mapping
            };

            STORAGE.setTokenData(tokenData);

            /* Set Members */
            if(data.society_str){
                STORAGE.setSocietyStructure(data.society_str);
            }

            if(data.members){
                MemberCtrl.storage_setMembers(data.members);
            }

            if(data.groups){
                WallCtrl.storage_setGroups(data.groups);
            }

            if(data.chats){
                MessageCtrl.storage_setRecentMessages(data.chats);
            }

            if(data.categories){STORAGE.setOptionList(data.categories);}

            Application.setPageShow("profile_home",0);


            /* if not mapped go to mapping page */
            if(!tokenData.profile.user_name || !tokenData.profile.user_image || !tokenData.profile.user_mobile_no){
                $.mobile.changePage('#profile_information');
                return ;
            }


            if(!tokenData.mapping.mapping_status){
                $.mobile.changePage('#profile_address');
                return ;
            }


            /* Redirect to wall if user on verification page */
            if(Application.getActivePage()=="profile_approval" && tokenData.mapping.mapping_status=="approved"){
                Notification.toast({message:"Congrats! your account has been activated. Please login to explore more!",alert:true});
                $.mobile.changePage('#society_wall');
            }

            if(oldTokenData && oldTokenData.mapping.mapping_status && oldTokenData.mapping.mapping_status!=tokenData.mapping.mapping_status && tokenData.mapping.mapping_status!="approved"){
                Notification.toast({message:"Sorry! Admin has "+tokenData.mapping.mapping_status+" your account. You may contact for more details",alert:true});
                $.mobile.changePage('#profile_approval');
            }

        },

        getSocietyStructure : function(){
            return SOCIETY_STRUCTURE;
        },

        getWingName : function(w_id){
            var str = ProfileCtrl.getSocietyStructure();
            if(str.wings.hasOwnProperty(w_id))
                return str.wings[w_id];
            return "-";
        },

        getFlatName : function(f_id){
            var str = ProfileCtrl.getSocietyStructure();
            if(str.flats.hasOwnProperty(f_id))
                return str.flats[f_id];
            return "-";
        },


        changeSociety : function(){

            var confirm = function(){

                var success = function(response){
                    Notification.toast({message:response.message,alert:true});
                    if(response.status==1){
                        ProfileCtrl.setTokenData(response.data);
                        STORAGE.resetStorageChange();
                        $.mobile.changePage('#profile_address');
                    }
                };
                AJAX.call({
                    url : {abs:"society/change"},
                    success:success,
                    async : true
                });
            };
            Notification.confirm({
                message : "Please confirm if you want to change your society",
                success:confirm
            });
        },

        logout : function(){

            $.mobile.loading("show");

            tokenData = false;

            STORAGE.resetStorage();
            STORAGE.removeToken();

            $.mobile.changePage("#user_index");

            setTimeout(function(){
                $.mobile.loading("hide");
            } ,2000);
        }

    };
}();
