var CONSTANT = function(){
    return {
        getErrorLogUrl : function(){
            if(Application.getEnv()=="local")
                return "http://192.168.1.99/cordova/Projects/societo@societo/website/private/logs/error/client/js.php";
            return "http://www.societo.in/newsocieto/private/logs/error/client/js.php";
        },
        getApiUrl : function(){
            if(Application.getEnv()=="local")
                return "http://192.168.1.99/cordova/Projects/societo@societo/website/";
            return "http://www.societo.in/newsocieto/";
        },
        getImageUrl : function(){
            if(Application.getEnv()=="local")
                return "http://192.168.1.99/cordova/Projects/societo@societo/website/";
            return "http://www.societo.in/newsocieto/";
        }
    }
}();

var AJAX = function(){

    var DEFAULTS;

    var successCallback = false;

    return {

        getSettings : function(){
            return  DEFAULTS = {
                type  : "POST",
                async : false,
                dataType:"JSON",
                beforeSend : AJAX.beforeSend,
                complete : AJAX.complete,
                error : AJAX.error,
                success : AJAX.success,
                url : CONSTANT.getApiUrl
            };
        },

        beforeSend : function(){$.mobile.loading('show');},
        complete : function(){$.mobile.loading('hide');},
        error : function(xhr,textStatus,errorThrown){$.mobile.loading('hide');
            /*Notification.toast(JSON.stringify(xhr)+JSON.stringify(textStatus)+JSON.stringify(errorThrown));*/
        },

        success : function(data){

            if(typeof data=="object" && data.hasOwnProperty("status") && data['status']=="-2"){
                var more = data['_more'];
                Notification.toast({message:data.message,alert:true});
                ProfileCtrl.logout();
                return ;
            }

            if(successCallback && typeof successCallback=="function"){
                successCallback(data);
            }
        },


        setSuccess : function(callBack){
            successCallback = callBack;
        },

        call : function(configs){

            if(isApp){
                try{
                    var networkState = navigator.connection.type;
                    if(networkState=="none"){
                        Notification.toast({message:"Please check Internet Connection !",alert:true});
                        return ;
                    }
                }catch(e){

                }
            }

            var  Settings = $.extend(this.getSettings(),configs);

            Settings.url =  CONSTANT.getApiUrl()+configs.url.abs;

            if(!Settings.data){
                Settings.data = {};
                Settings.data.ctoken=ProfileCtrl.getToken();
            }else{
                if(typeof Settings.data=="string"){
                    Settings.data+="&ctoken="+ProfileCtrl.getToken();
                }else if(typeof Settings.data=="object"){
                    Settings.data.ctoken=ProfileCtrl.getToken();
                }else{alert("UNABLE TO SEND CLIENT TOKEN");}
            }

            $.ajax({
                url:Settings.url,
                dataType:Settings.dataType,
                async : Settings.async,
                beforeSend:Settings.beforeSend,
                type:Settings.type,
                complete:Settings.complete,
                error: Settings.error,
                data:Settings.data,
                success:function(data){

                    if(typeof data=="object" && data.hasOwnProperty("status") && data['status']=="-2"){
                        var more = data['_more'];
                        Notification.toast({message:data.message,alert:true});
                        ProfileCtrl.logout();
                        return ;
                    }

                    if(Settings.success && typeof Settings.success=="function"){
                        Settings.success(data);
                    }
                }, //
            });
        }
    };/* End Return  */
}();

var GOOGLE = function(){

    var handleCityAutoComplete = function () {
        optionCity = {types: ['(cities)'], componentRestrictions: {country: "in"}};
        autocomplete_city = new google.maps.places.Autocomplete(document.getElementById('user_address_description'), optionCity);
        google.maps.event.addListener(autocomplete_city, 'place_changed', function () {
            place = autocomplete_city.getPlace();
            vs_debugger = place;

            $('#user_address_google').val("");
            $('#user_address_google').show();
            $('label[for="user_address_google"]').show();
            handleAreaAutoComplete(place.geometry.viewport.getSouthWest(), place.geometry.viewport.getNorthEast());
        });
    };

    var handleAreaAutoComplete = function (getSouthWest, getNorthEast) {

        var optionArea = {
            bounds: new google.maps.LatLngBounds(getSouthWest, getNorthEast),
            componentRestrictions: {country: "in"}
        }

        autocomplete_area = new google.maps.places.Autocomplete(document.getElementById('user_address_google'), optionArea);

        google.maps.event.addListener(autocomplete_area, 'place_changed', function () {

            place = autocomplete_area.getPlace();

            $('.addressHiddenElements').val("");

            addressObject = place.address_components;

            prefix = "user";

            for (var i = 0; i < addressObject.length; i++) {
                for (var b = 0; b < addressObject[i].types.length; b++) {
                    switch (addressObject[i].types[b]) {
                        case "neighborhood":
                            $('#' + prefix + '_address_sublocality').val(addressObject[i].long_name);
                            break;
                        case "sublocality_level_1":
                            $('#' + prefix + '_address_locality').val(addressObject[i].long_name);
                            break;
                        case "postal_code":
                            $('#' + prefix + '_address_zipcode').val(addressObject[i].long_name);
                            break;
                        case "administrative_area_level_2":
                            $('#' + prefix + '_address_city').val(addressObject[i].long_name);
                            break;
                        case "administrative_area_level_1":
                            $('#' + prefix + '_address_state').val(addressObject[i].long_name);
                            break;
                        case "country":
                            $('#' + prefix + '_address_country').val(addressObject[i].long_name);
                            break;
                    }
                }
                //  $('.addressHiddenElements').show();
            }
            $("#user_address_latitude").val(place.geometry.location.lat());
            $("#user_address_longitude").val(place.geometry.location.lng());

        });
    };

    return {

        setAutoComplete : function(request){
            var optionArea = {componentRestrictions: {country: "in"}};
            var element = new google.maps.places.Autocomplete($(request.selector.input)[0], optionArea);
            google.maps.event.addListener(element, 'place_changed', function () {
                place = element.getPlace();
                $(request.selector.lat).val(place.geometry.location.lat());
                $(request.selector.lng).val(place.geometry.location.lng());
            });
        },

        getGeoLocation : function(request){

            var onSuccess = function(position){
                if(position.coords.latitude != "undefined"){
                    request.success({
                        latitude :position.coords.latitude,
                        longitude : position.coords.longitude
                    });
                }
            };

            var onError = function(error) {
                var  msg;
                if (error.code == 1) {
                    msg= "App doesn't have permission to use GPS";
                } else if (error.code == 2) {
                    msg= "No GPS device found";
                } else if (error.code == 3) {
                    msg= "Its taking too long find user location";
                } else {
                    msg= "An unknown error occured";
                }
                request.error(msg);
            };

            navigator.geolocation.getCurrentPosition(onSuccess,onError,{maximumAge: 3000, timeout: 5000, enableHighAccuracy: true });

        },

        getZipDetails : function(request){
            var geocoder = new google.maps.Geocoder();
            geocoder.geocode({'address': request.code+",India"}, function (results, status) {
                if (status == google.maps.GeocoderStatus.OK) {
                    var location =  {
                        latitude : results[0].geometry.location.lat(),
                        longitude : results[0].geometry.location.lng()
                    };
                    request.success(location);

                } else {
                    if(request.hasOwnProperty("error")){
                        request.error();
                    }
                }
            });
        },

        getZipCode : function(place){

            for (var i=0; i<place.address_components.length;i++){
                for (var j=0;j<place.address_components[i].types.length;j++){
                    if (place.address_components[i].types[j] == "postal_code"){
                        return place.address_components[i].long_name;
                    }
                }
            }

            return false;
        }
    }
}();

var DATE = function(){

    var formatAMPM = function (date , h) {
        var hours = date.getHours();
        var minutes = date.getMinutes();
        var ampm = hours >= 12 ? 'pm' : 'am';
        hours = hours % 12;
        hours = hours ? hours : 12; // the hour '0' should be '12'
        minutes = minutes < 10 ? '0'+minutes : minutes;

        if(h && h=="h")
            return hours;

        if(h && h=="a")
            return ampm;

        if(h && h=="A")
            return ampm.toUpperCase();

        return  hours + ':' + minutes + ' ' + ampm;
    };

    var getMonthName = function(index,short){
        var full = ["January", "February", "March", "April", "May", "June","July", "August", "September", "October", "November", "December"];

        var short = ["Jan", "Feb", "Mar", "Apr", "May", "Jun","Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];

        if(typeof short!="undefined" && short == 'short' )
            return short[index];

        return full[index];
    };

    return{

        getFromUnix : function(unix,format){

            var date = new Date(unix*1000);

            var d = date.getDate(),
                m = date.getMonth(),
                Y = date.getFullYear(),
                h = formatAMPM(date,"h"),
                i = date.getMinutes(),
                s = date.getSeconds(),
                A = formatAMPM(date,"A"),
                a = formatAMPM(date,"a");


            switch(format){
                case "d-M-Y" : return [d,getMonthName(m),Y].join("-"); break;
                case "h:i d-M-Y" : return  h+":"+i+" "+A+" "+[d,getMonthName(m),Y].join("-");break;
                case "h:i" : return h+":"+i+" "+A; break;
                case "h:i A" : return h+":"+i+" "+A; break;
                case "M" : return getMonthName(m); break;
                case "Y" : return Y; break;
                case "d" : return d; break;
                default : return [d,getMonthName(m),Y].join("-");
            }
        },

        showPicker  : function(element){
            var configs = $(element).data('configs');
            if(isApp){
                var options = {
                    date: new Date(),
                    mode: configs.format,
                    androidTheme : 5
                };

                function onSuccess(date) {
                    switch(configs.format){
                        case "time" :  element.value = moment(date).format("hh:mm A"); break;
                        case "date" : element.value = moment(date).format("DD-MMM-YYYY");  break;
                        case "datetime" : element.value = moment(date).format("hh:mm A")+" "+moment(date).format("DD-MMM-YYYY");    break;
                    }
                }

                function onError(error) { // Android only
                    //alert('Error: ' + error);
                }

                datePicker.show(options, onSuccess, onError);

            }else{

                var  date = new Date();

                $(element).removeAttr("readonly");

                if(configs.format=="date"){
                    element.value = moment(date).format("DD-MMM-YYYY");
                }

                if(configs.format=="time"){
                    element.value = moment(date).format("hh:mm A");
                }

                if(configs.format=="datetime"){
                    element.value = moment(date).format("hh:mm A")+" "+moment(date).format("DD-MMM-YYYY");
                }

            }
        }
    };
}();

var Notification = function(){
    return {
        alert : function(param){
            try{
                navigator.notification.alert(param)
            }catch(e){
                alert(param);
            }
        },
        toast : function(configs){

            var message, show_alert = false ;

            if(typeof configs=="object"){

                if(configs.hasOwnProperty('message') && configs['message']){
                    message = configs.message;
                }

                if(configs.hasOwnProperty('alert') && configs['alert']){
                    show_alert = true;
                }
            }else{
                message = configs;
            }

            if(window.plugins){
                try{
                    window.plugins.toast.showShortBottom(message);
                }catch(e){
                    if(show_alert){
                        Notification.alert(message);
                    }
                }
            }else{
                if(show_alert){
                    Notification.alert(message);
                }
            }
        },
        confirm : function(configs){
            try{
                navigator.notification.confirm(configs.message,function(index){if(index==1){configs.success()}});
            }catch(e){
                var cofirmBox = confirm(configs.message);
                if(cofirmBox){
                    configs.success();
                }
            }
        },
        beep : function(){}
    }
}();

var IMAGE = function () {

    var imageDefaults = {
        "quality": 70,
        "max-width": 800,
        "max-height": 800
    };

    var REQUEST = {};

    return {

        getUrl : function(type,name,size){

            var url = CONSTANT.getImageUrl();

            var TYPES = {
                "soSmart" : {"default" : "img/default/soSmart.png" , path : "public/resources/mms_images/" , size: "60"},
                "wall" : {"default" : "img/default/wall.png" , path : "public/resources/wall_uploads/" , size: "thumb"},
                "profile" : {"default" : "img/default/user.png" , path : "public/resources/profile_images/" , size: "60"}
            };

            if(!type)
                return "img/default/default.png";

            if(!name)
                return TYPES[type]["default"];

            if(!size)
                size = TYPES[type]["size"];

            return url+TYPES[type]["path"]+"/"+size+"/"+name;
        },

        /* Create Slider and return Ids */
        createGallery : function(gallery,obj){

            if(typeof gallery!="object"){
                try{
                    gallery = JSON.parse(gallery);
                }catch(e){
                    return {status : false};
                }
            }

            if(!gallery){
                gallery = [""];

            }


            var time = new Date().getTime();

            var template = $("#swiper-slider-structure").html();

            var sliders = "";

            /* Create All Slides */
            for(var i=0;i<gallery.length;i++){
                sliders += '<div class="swiper-slide"><img src="'+IMAGE.getUrl("wall",gallery[i])+'" style="width: 100%;"></div>';
            }

            template = template.replace(new RegExp("{{slides}}","g"),sliders).replace(new RegExp("{{time}}","g"),time);

            return {
                status : true,
                html : template,
                time : time
            };
        },

        initSwiper : function(obj){
            if(obj.hasOwnProperty('time') && obj.time){
                var time = obj.time;

                var swiper = new Swiper('#swiper-'+time, {
                    pagination: '.swiper-pagination-'+time,
                    paginationClickable: true,
                    nextButton: '.swiper-button-next-'+time,
                    prevButton: '.swiper-button-prev-'+time,
                    autoHeight: true
                });
            }
        },




        getQuality: function () {return imageDefaults["quality"];},
        getMaxWidth: function () {return imageDefaults["max-width"];},
        getMaxHeight: function () {return imageDefaults["max-height"];},

        getRequest : function(){return REQUEST;},
        setRequest : function(value){return REQUEST = value;},


        /* Container */
        resetContainer : function(){
            var container = IMAGE.getContainer();
            $(container).html("");
            return container;
        },

        getContainer : function(){
            var pageId = Application.getActivePage();
            var image_container = $('#' + pageId + " .image-preview-container");
            if(image_container.length==0){
                $('#'+pageId+" #"+REQUEST['element']).after("<div class='image-preview-container'></div>");
                image_container = $('#' + pageId + " .image-preview-container");
            }
            return image_container[0];

        },

        browse : function(){

            var pageId = Application.getActivePage();

            var pageConfigs = Application.getPageConfig(pageId);

            var imageConfig ;

            try{
                imageConfig = pageConfigs['view']['form']['image'];
            }catch(e){
                return false;
            }

            IMAGE.setRequest(imageConfig);

            if(isApp){
                IMAGE.browseAppImage();
            }else{
                IMAGE.browseWebImage();
            }

            return true;
        },

        browseAppImage : function(){

            var cameraSuccess = function(imageData){
                var src = "data:image/jpeg;base64," + imageData;
                IMAGE.displayImage(src);
            };

            var cameraError = function(message){
                Notification.toast({message:message,alert:true});
            };

            navigator.camera.getPicture(cameraSuccess, cameraError, {
                mediaType : 0,
                destinationType : 0,
                sourceType:0,
                quality : IMAGE.getQuality(),
                targetWidth : IMAGE.getMaxWidth(),
                targetHeight : IMAGE.getMaxHeight()
            });

        },

        browseWebImage : function(){

            var pageId = Application.getActivePage();

            var fileInput =  $("#"+pageId+' #'+REQUEST['element'])[0];

            fileInput.onchange = function(){

                if (!(window.File && window.FileReader && window.FileList && window.Blob ) ) {
                    Notification.toast({message:'The File APIs are not fully supported in this browser.',alert:true});
                    return false;
                }

                var file = fileInput.files[0];

                if (!(/image/i ).test(file.type)) {
                    Notification.toast({message:"File " + file.name + " is not an image."});
                    return false;
                }

                var processImage = function(file){

                    var getImageBaseCode = function(image){

                        var canvas = document.createElement('canvas'), width = image.width, height = image.height;

                        if (width > height) {
                            if (width > IMAGE.getMaxWidth()) {
                                height = Math.round(height *= IMAGE.getMaxWidth() / width);
                                width = IMAGE.getMaxWidth();
                            }
                        }else {
                            if (height > IMAGE.getMaxHeight()) {
                                width = Math.round(width *= IMAGE.getMaxHeight() / height);
                                height = IMAGE.getMaxHeight();
                            }
                        }
                        canvas.width = width;
                        canvas.height = height;
                        var ctx = canvas.getContext("2d");
                        ctx.drawImage(image, 0, 0, width, height);
                        return canvas.toDataURL("image/jpeg",(IMAGE.getQuality()/100));

                    };

                    var reader = new FileReader();

                    reader.readAsArrayBuffer(file);

                    reader.onload = function (event) {

                        var blob = new Blob([event.target.result]);

                        window.URL = window.URL || window.webkitURL;

                        var blobURL = window.URL.createObjectURL(blob);

                        var image = new Image();

                        image.src = blobURL;

                        image.onload = function () {
                            IMAGE.displayImage(getImageBaseCode(image));
                        }
                    };
                };

                processImage(fileInput.files[0]);

                fileInput.value = "";
            };
            fileInput.click();
        },

        displayImage : function(src){ //form-img-preview

            var pageId = Application.getActivePage();

            var image_container = IMAGE.getContainer();

            if(REQUEST.hasOwnProperty('profile')){
                image_container = $('.form-img-preview-dp')[0];
            }

            var imageIndex = new Date().getTime();

            var imageElement = "<div class='img-preview-item' data-item-index = '"+imageIndex+"'><p class='img-close' onclick='IMAGE.removeImage(this);' >X</p><img src='"+src+"'  ></div>";

            if(REQUEST['multiple']==true) {
                $(image_container).before('<input type="hidden" name="'+REQUEST['element']+'_string[]" data-item-index="'+imageIndex+'" value="'+src+'" >');
            }else{
                /* Check Element Exists of not */
                var stringElement = $('#'+pageId+" [name="+REQUEST['element']+"_string]");

                if(stringElement.length==0){
                    $(image_container).before('<input type="hidden" name="'+REQUEST['element']+'_string">');
                    stringElement = $('#'+pageId+" [name="+REQUEST['element']+"_string]");
                }

                var element_string = stringElement[0];

                $(element_string).data('item-index',imageIndex);
                $(element_string).val(src);

                $(image_container).html("");
            }

            $(image_container).append(imageElement);
        },

        removeImage : function(obj){
            var itemIndex = $(obj).parent('.img-preview-item').attr('data-item-index');
            $("[data-item-index='"+itemIndex+"']").remove();
        },


        /* OLD */

        browseImageMultiple : function(request){

            var btn = $(request.btn);
            var configs = $(btn).data('configs');

            var pageId = $.mobile.activePage.attr('id');
            var fileInput =  $("#"+pageId+' #'+configs['file_element'])[0];

            IMAGE.setBtn(btn);
            IMAGE.setConfigs(configs);


            if(isApp){

                var cameraSuccess = function(imageData){

                    var img_wrapper = $("#"+pageId+" .form-img-preview");

                    if(img_wrapper.length==0){
                        $("#"+pageId+" #"+configs.file_element).after("<div class='form-img-preview'></div>");
                        img_wrapper = $("#"+pageId+" .form-img-preview");
                    }

                    src = "data:image/jpeg;base64," + imageData;

                    if(configs.multiple==true){
                        $("#"+pageId+" #"+configs.file_element).after('<input type="hidden" name="'+configs.string_element+'[]" id="'+configs.string_element+'" value="'+src+'" >');
                    }else{
                        $("#"+pageId+" #"+configs['string_element']).val(src);
                    }

                    img_wrapper.append("<img src='"+src+"' />");

                };

                var cameraError = function(message){
                    Notification.toast({message:message});
                };

                navigator.camera.getPicture(cameraSuccess, cameraError, {
                    mediaType : 0,
                    destinationType : 0,
                    sourceType:0,
                    quality : IMAGE.getQuality(),
                    targetWidth : IMAGE.getMaxWidth(),
                    targetHeight : IMAGE.getMaxHeight()
                });

            }else{
                fileInput.onchange = function(){
                    if (!(window.File && window.FileReader && window.FileList && window.Blob ) ) {
                        Notification.toast({message:'The File APIs are not fully supported in this browser.',alert:true});
                        return false;
                    }
                    IMAGE.processfile(fileInput.files[0]);
                    fileInput.value = "";
                };
                fileInput.click();
            }
        },

        browseImage : function(request){

            var btn = $(request.btn);
            var configs = $(btn).data('configs');
            var attachment = false;

            if(request.hasOwnProperty('attachment') && request.attachment){

                attachment = true;

            }

            IMAGE.setBtn(btn);
            IMAGE.setConfigs(configs);
            IMAGE.setRequest(request);

            if(isApp){

                var cameraSuccess = function(imageData) {

                    if(!(request.hasOwnProperty('profile_image') && request["profile_image"])){

                        $('.form-img-preview').remove();

                        $("#"+ $.mobile.activePage.attr('id')+" #"+configs.file_element ).after("<div class='form-img-preview'></div>");

                    }else{
                        $('.form-img-preview-dp').empty();//
                    }


                    src = "data:image/jpeg;base64," + imageData;

                    $("#"+$.mobile.activePage.attr("id")+" #"+configs['string_element']).val(src);


                    if(!(request.hasOwnProperty('profile_image') && request["profile_image"])){
                        $('.form-img-preview').append("<div class='form-img-preview'><img src='"+src+"' /></div>");
                    }else{
                        $('.form-img-preview-dp').append("<div class='form-img-preview'><img src='"+src+"' /></div>");
                    }

                };

                var cameraError = function(message){
                    Notification.toast({message:message});
                };

                navigator.camera.getPicture(cameraSuccess, cameraError, {
                    quality : 75,
                    mediaType : 0,
                    destinationType : 0,
                    sourceType:0,
                    targetWidth : 1000,
                    targetHeight : 800
                });

            }else{

                var fileinput = $("#"+ $.mobile.activePage.attr('id')+' #'+configs['file_element'])[0];

                if(attachment){
                    $("#"+ $.mobile.activePage.attr('id')+' #'+configs['file_element']).trigger('click');
                    return true;

                }

                fileinput.onchange = function(){

                    if ( !( window.File && window.FileReader && window.FileList && window.Blob ) ) {
                        alert('The File APIs are not fully supported in this browser.');
                        return false;
                    }

                    IMAGE.processfile(fileinput.files[0],btn,configs);

                    if(request.hasOwnProperty('profile_image') && request["profile_image"]){
                        $('.content_profile_image .img-preview img').hide();
                        /*$(btn).html("Change Image");*/
                        $('#btn_profile_image_submit').show();
                    }


                    fileinput.value = "";
                };

                $("#"+ $.mobile.activePage.attr('id')+' #'+configs['file_element']).trigger('click');


            }
        },
    }
}();

var PushCtrl = function () {

    var STORAGE_INDEX = "Push-RegistrationId";

    var registration_id;

    var push;

    return {

        init: function () {

            push = PushNotification.init({
                "android": {"senderID": "561120027647"},
                "ios": {"alert": "true", "badge": "true", "sound": "true",
                    "categories": {
                        "invite": {
                            "yes": {
                                "callback": "app.accept", "title": "Accept", "foreground": true, "destructive": false
                            },
                            "no": {
                                "callback": "app.reject", "title": "Reject", "foreground": true, "destructive": false
                            },
                            "maybe": {
                                "callback": "app.maybe", "title": "Maybe", "foreground": true, "destructive": false
                            }
                        },
                        "delete": {
                            "yes": {
                                "callback": "app.doDelete", "title": "Delete", "foreground": true, "destructive": true
                            },
                            "no": {
                                "callback": "app.cancel", "title": "Cancel", "foreground": true, "destructive": false
                            }
                        }
                    }
                },
                "windows": {}
            });

            if (!PushCtrl.getRegistrationId()){
                push.on('registration', PushCtrl.onPushRegister);
            }else{
                PushCtrl.updateClientInfo();
            }

            push.on('notification', PushCtrl.onPushNotification);

            push.on('error', PushCtrl.onPushError);
        },

        getRegistrationId: function () {return localStorage.getItem(STORAGE_INDEX);},

        setRegistrationId: function (value) {localStorage.setItem(STORAGE_INDEX, value);return value;},

        updateClientInfo : function(){

            setTimeout(function(){
                if(ProfileCtrl.getUserId()){
                    AJAX.call({
                        url : {"abs":"profile/updateclient"},
                        data : {
                            uat_device_type : AppDevice.getPlatform(),
                            uat_device_name : AppDevice.getModel(),
                            uat_app_version : AppDevice.getAppVersion(),
                            uat_version_code : AppDevice.getAppBuild(),
                            uat_push_token : PushCtrl.getRegistrationId()
                        },
                        async:true,
                        beforeSend : function(){},
                        success : function(){},
                        error : function(){}
                    });
                }
            },3000);
        },

        onPushRegister: function (data) {PushCtrl.setRegistrationId(data.registrationId);},

        onPushError: function (error){Notification.toast({message:error.message,alert:true});},

        onPushNotification: function (data){

            var extraData = data['additionalData'].hasOwnProperty("extra")?data['additionalData']['extra']:false;

            if(extraData){
                PushCtrl.onPushRedirect(extraData);
            }else{
                if(ProfileCtrl.getUserId()){
                    $.mobile.changePage("#society_wall");
                }else{
                    $.mobile.changePage("#user_index");
                }
            }
        },

        onPushRedirect : function(data){

            var TYPE = data["T"];
            var PARAM = data["P"];

            switch(TYPE){
                case "WALL" :
                    /* Parameters
                     *   m->module [society|office|group|event]
                     *   mid->module_id [int]
                     *
                     *  */
                    switch(PARAM.M){

                        case "society":
                            WallCtrl.setModule("society");
                            WallCtrl.setModuleId(ProfileCtrl.getSocietyId());

                            if(Application.getActivePage()=="society_wall"){
                                WallCtrl.refreshWall();
                            }else{
                                $.mobile.changePage("society_wall");
                            }
                            break;

                        case "soshare":
                            WallCtrl.setModule("soshare");
                            WallCtrl.setModuleId(ProfileCtrl.getSocietyId());

                            if(Application.getActivePage()=="soshare_wall"){
                                WallCtrl.refreshShowWallSoShare();
                            }else{
                                $.mobile.changePage("soshare_wall");
                            }
                            break;


                        case "group":
                            WallCtrl.setModule("group");
                            WallCtrl.setModuleId(PARAM.M_ID);
                            if(Application.getActivePage()=="society_group_wall"){
                                $("#society_group_wall").trigger("pageshow");
                            }else{
                                $.mobile.changePage("society_group_wall");
                            }
                            break;

                        case "event":
                            WallCtrl.setModule("event");
                            WallCtrl.setModuleId(PARAM.M_ID);
                            if(Application.getActivePage()=="society_event_wall"){
                                $("#society_event_wall").trigger("pageshow");
                            }else{
                                $.mobile.changePage("society_event_wall");
                            }
                            break;
                    }
                    break;


                case "GRP-J" : /*Group Joined Office*/
                    Application.setPageShow('group_joined',-1);
                    $.mobile.changePage("#group_joined");
                    break;

                case "GRP-A" : /*Group Available Office*/
                    Application.setPageShow('group_available',-1);
                    $.mobile.changePage("#group_available");
                    break;

                case "MSG":/* Message */
                    MessageCtrl.goToChat(PARAM.UID,Application.getActivePage());
                    break;

                case "MEMBERS":/* CIO Members */
                    Application.setPageShow('member_list',-1);
                    $.mobile.changePage('#member_list');
                    break;


                case "New-Member":
                    Application.setPageShow('member_list',-1);
                    $.mobile.changePage('#member_list');
                    MemberCtrl.triggerFilter('member-item','new');
                    break;

                case "Account-Approved":
                case "Account-Reject":
                case "Account-Blocked":
                case "Account-Unblocked":
                case "Account-Mark-Admin":
                case "Account-Mark-Member":
                    ProfileCtrl.syncServer();
                    break;
                default :

            }
        }
    }
}();

var AppDevice = function () {
    var model="", platform="browser", uuid="", version="", app_version="", build="";
    return {
        getModel: function(){return model;},
        setModel: function(){return model = device.model;},
        getPlatform: function (){return platform;},
        setPlatform: function () {return platform = device.platform;},
        getUuid: function (){return uuid;},
        setUuid: function () {return uuid = device.uuid;},
        getVersion: function () {return version;},
        setVersion: function () {return version = device.version;},
        getAppVersion: function () {return app_version;},
        setAppVersion: function () {return app_version = AppVersion.version;},
        getAppBuild: function () {return build;},
        setAppBuild: function () {return build = AppVersion.build;},
        init: function () {
            this.setModel();
            this.setPlatform();
            this.setUuid();
            this.setVersion();
            this.setAppVersion();
            this.setAppBuild();
        }
    }
}();

var ContactSync = function(){

    /*
     * Storage  :
     * Local Sync Date : CONTACTS_SYNC_LOCAL
     * Server Sync Date : CONTACTS_SYNC_SERVER
     *

     * */

    return {

        storage_getContacts : function(){
            return JSON.parse(localStorage.getItem("CONTACTS_LIST"));
        },
        storage_setContacts : function(data){

            localStorage.setItem("CONTACTS_LIST",JSON.stringify(data));


            /*  Update Last Local Sync Date*/
            ContactSync.storage_setLastSyncLocal();

            /* Update Last Server Sync Date*/
            ContactSync.storage_setLastSyncServer();

            ContactSync.sync_online();

        },

        storage_getLastSyncServer : function(){return localStorage.getItem("CONTACTS_SYNC_SERVER");},
        storage_setLastSyncServer : function(){return localStorage.setItem("CONTACTS_SYNC_SERVER",getDate());},

        storage_getLastSyncLocal : function(){return localStorage.getItem("CONTACTS_SYNC_LOCAL");},
        storage_setLastSyncLocal : function(){return localStorage.setItem("CONTACTS_SYNC_LOCAL",getDate());},

        sync_online : function(contacts){
            AJAX.call({
                url : {abs:"profile/savecontact"},
                data : {data:JSON.stringify(contacts),"user_id":ProfileCtrl.getUserId()},
                async:true,
                beforeSend : function(){},
            });
        },

        sync_local : function(){

            var onError = function(){

            };

            var onSuccess = function(contacts) {
                var formatted_contacts = [];
                for (var i = 0; i < contacts.length; i++) {
                    var item = contacts[i];
                    var temp = {
                        name : item.displayName,
                        emails :[],
                        phoneNumbers : []
                    };
                    if(item.phoneNumbers && item.phoneNumbers.length > 0){
                        for(j=0;j<item.phoneNumbers.length;j++){
                            if(item.phoneNumbers[j].value.length > 5 && temp.phoneNumbers.indexOf(item.phoneNumbers[j].value)==-1){
                                temp.phoneNumbers.push(item.phoneNumbers[j].value);
                            }
                        }
                    }else{
                        continue;
                    }

                    if(item.emails && item.emails.length > 0){
                        for(j=0;j<item.emails.length;j++){
                            if(temp.emails.indexOf(item.emails[j].value)==-1){
                                temp.emails.push(item.emails[j].value);
                            }
                        }
                    }

                    formatted_contacts.push(temp);
                }

                ContactSync.storage_setContacts(formatted_contacts);
            };

            var options      = new ContactFindOptions();
            options.filter   = "";
            options.multiple = true;
            options.desiredFields = [navigator.contacts.fieldType.id];
            options.hasPhoneNumber = true;
            var fields = [navigator.contacts.fieldType.name,navigator.contacts.fieldType.phoneNumbers,navigator.contacts.fieldType.emails];
            navigator.contacts.find(fields, onSuccess, onError, options);



        },

        init : function(){
            ContactSync.sync_local();
        }
    }
}();

var STORAGE = function(){

    return {
        setTokenData : function(data){
            localStorage.setItem("USER_TOKEN_DATA",JSON.stringify(data));
        },

        getTokenData : function(){

            var data = JSON.parse(localStorage.getItem("USER_TOKEN_DATA"));

            if(!data){
                return false;
            }

            var user_roles = [];

            user_roles.push("m");

            if(data.mapping){
                if(data.mapping['mapping_status']=="approved"){
                    if(data.mapping['role']=="admin"){
                        user_roles.push("sa");
                        user_roles.push("sm");
                    }else{
                        user_roles.push("sm");
                    }
                }else{
                    user_roles.push("sg");
                }
            }else{
                user_roles.push("su");
            }

            data['user_roles'] = user_roles;

            return data;
        },

        removeToken : function(){
            return localStorage.removeItem("USER_TOKEN_DATA");
        },

        getTokenRoles : function(){
            var roles = [];
            roles.push("*");

            var data = STORAGE.getTokenData();
            if(data){
                return data['user_roles'];
            }else{
                roles.push("g");
            }
            return roles;
        },

        resetStorage : function(){
            localStorage.removeItem("MESSAGE_CHAT");
            localStorage.removeItem("MESSAGE_RECENT");
            localStorage.removeItem("NEAR_BY_PLACES");
            localStorage.removeItem("SocietyMembers");
            localStorage.removeItem("WALL_GROUPS");
            localStorage.removeItem("WALL_POSTS");
            STORAGE.resetNews();
        },


        /*
         * Method Reset Page Local Offsets
         * */
        resetOffsets : function(){
            WallCtrl.resetOffset(); /* Clear Wall Offsets */
        },


        /*
         * Method Reset Storage on Change Society
         *   Calling Point > ProfileCtrl.changeSociety();
         * */
        resetStorageChange : function(){
            STORAGE.resetStorage();
            STORAGE.resetOffsets();
        },


        setSocietyStructure : function(data){return localStorage.setItem("SOCIETY_STRUCTURE",JSON.stringify(data));},
        getSocietyStructure : function(){ return JSON.parse(localStorage.getItem("SOCIETY_STRUCTURE"));},

        setOptionList : function(data){return localStorage.setItem("OPTION_LIST",JSON.stringify(data));},
        getOptionList : function(type){var items = JSON.parse(localStorage.getItem("OPTION_LIST"));return items[type];},


        /*Society News*/
        getNewsSyncDate : function(){return localStorage.getItem("NEWS_SYNC_DATE");},
        setNewsSyncDate : function(){return localStorage.setItem("NEWS_SYNC_DATE",getDate());},

        getNews : function(){
            if(STORAGE.getNewsSyncDate()!=getDate()){
                return null;
            }
            return JSON.parse(localStorage.getItem("NEWS_FEEDS"));
        },
        setNews : function(items){STORAGE.setNewsSyncDate();return localStorage.setItem("NEWS_FEEDS",JSON.stringify(items));},



        /*Group News*/
        setGroupNewsSyncDate : function(id){
            var data = JSON.parse(localStorage.getItem("GROUP_NEWS_SYNC_DATE"));

            if(!data) data = {};

            data[id] = getDate();

            return localStorage.setItem("GROUP_NEWS_SYNC_DATE",JSON.stringify(data));
        },
        getGroupNewsSyncDate : function(id){
            var data = JSON.parse(localStorage.getItem("GROUP_NEWS_SYNC_DATE"));

            if(data && data.hasOwnProperty(id)){
                return data[id]
            }

            return false;
        },
        getGroupNews : function(id){

            var news = JSON.parse(localStorage.getItem("GROUP_NEWS_FEEDS"));

            if(news && news.hasOwnProperty(id)){
                if(STORAGE.getGroupNewsSyncDate(id)!=getDate()){
                    return null;
                }
                return news[id];
            }

            return false;
        },
        setGroupNews : function(id,items){
            STORAGE.setGroupNewsSyncDate(id);

            var news = JSON.parse(localStorage.getItem("GROUP_NEWS_FEEDS"));

            if(!news)
                news = {};

            news[id]  = items;

            return localStorage.setItem("GROUP_NEWS_FEEDS",JSON.stringify(news));
        },






        resetNews : function(){
            localStorage.removeItem("NEWS_SYNC_DATE");
            localStorage.removeItem("NEWS_FEEDS");
        }
    }
}();

var Application = function () {

    var ENV;

    var PAGE_CONFIGS =  {

        "user_index" : {
            "title" : "Home",
            "isPageShow" : 0,
            "header" : false,
            "events" : {"pageInit" : "GuestCtrl.pageInitIndex"} ,
            "left-panel" : false,
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":false},
            "access" : ["g"],
            "view" : {
                "template" : false,
                "form" : {id: 'frm_login_email', action: 'auth/email', reset:true, onSubmit : "GuestCtrl.onSubmitLoginEmail"}
            },

        },

        "user_login" : {
            "title" : "Login",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "events" : {"pageShow":"GuestCtrl.pageShowLogin"},
            "left-panel" : false,
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"#user_index"},
            "access" : ["g"],
            "view" : {
                "template" : {url:"js/MVC/View/guest/login.html"},
                "form" : {
                    id: 'frm_login',
                    action: 'auth/login',
                    reset:true,
                    onSubmit : "GuestCtrl.onSubmitLogin",
                    footer: {
                        template : {
                            id:"template-footer-form-1-1",
                            replace:{"{{submitLabel}}":"Submit"}
                        }
                    },

                }
            }
        },

        "user_started" : {
            "title" : "Get Started",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : false,
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"#user_index"},
            "access" : ["g"],
            "view" : {
                "template" : {url:"js/MVC/View/guest/started.html"},
                "form" : {
                    id: 'frm_user_started',
                    action: 'auth/started',
                    reset:true,
                    onSubmit : "GuestCtrl.onSubmitStarted",
                    footer: {
                        template : {
                            id:"template-footer-form-1-1",
                            replace:{"{{submitLabel}}":"Go"}
                        }
                    },
                }
            }
        },

        "user_register" : {
            "title" : "Register",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "events" : {"pageShow":"GuestCtrl.pageShowRegister"},
            "left-panel" : false,
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":false},
            "access" : ["g"],
            "view" : {
                "template" : {url:"js/MVC/View/guest/register.html"},
                "form" : {
                    id: 'frm_register',
                    action: 'auth/register',
                    reset:true,
                    footer: {
                        template : {
                            id:"template-footer-form-1-1",
                            replace:{"{{submitLabel}}":"Submit"}
                        }
                    },
                    onSubmit : "GuestCtrl.onSubmitRegister"
                }
            }
        },

        "user_activation" : {
            "title" : "Activate Account",
            "isPageShow" : 0,
            "header" : "guest",
            "left-panel" : false,
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":false},
            "access" : ["g"],
            "view" : {
                "template" : {url:"js/MVC/View/guest/activate_account.html"},
                "form" : {id: 'frm_activation', action: 'auth/activation', reset:true, onSubmit : "GuestCtrl.onSubmitActivation"}
            }
        },

        "user_forgotPassword" : {
            "title" : "Forgot Password",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : false,
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"#user_login"},
            "access" : ["g"],
            "view" : {
                "template" : {url:"js/MVC/View/guest/forgot_password.html"},
                "form" : {
                    id: 'frm_forgot_password',
                    action: 'auth/forgot',
                    reset:true,
                    footer: {
                        template : {
                            id:"template-footer-form-1-1",
                            replace:{"{{submitLabel}}":"Submit"}
                        }
                    },
                    onSubmit : "GuestCtrl.onSubmitForgotPassword"
                }
            }
        },

        "user_mobile_verification" : {
            "title" : "Login OTP",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "events" : {"pageShow":"GuestCtrl.pageShowMobileVerification"},
            "left-panel" : false,
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":false},
            "access" : ["g"],
            "view" : {
                "template" : {url:"js/MVC/View/guest/mobile_verification.html"},
                "form" : {
                    id: 'frm_mobile_verification',
                    action: 'auth/mobileverification',
                    reset:true,
                    footer: {
                        template : {
                            id:"template-footer-form-1-1",
                            replace:{"{{submitLabel}}":"Verify"}
                        }
                    },
                    onSubmit : "GuestCtrl.onSubmitMobileVerification"
                }
            }
        },

        "static_about" : {
            "title" : "About Us",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : false,
            "events" : {"pageShow":"GuestCtrl.pageShowAboutUs"},
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["*"],
            "view" : {
                "template" : false,
                "x-pull" : true,
                "refresh" : "GuestCtrl.refreshAboutUs"
            }
        },

        "static_legal" : {
            "title" : "Terms Of Use",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : false,
            "events" : {"pageShow":"GuestCtrl.pageShowTerms"},
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["*"],
            "view" : {
                "template" : false,
                "x-pull" : true,
                "refresh" : "GuestCtrl.refreshTerms"
            }
        },

        "static_contact":{
            "title" : "Contact Us",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : false,
            "events" : {"pageShow":"GuestCtrl.pageShowContact"},
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["*"],
            "view" : {
                "template" : {url:"js/MVC/View/guest/contact_us.html"},
                "form" : {
                    id: 'frm_contact_us',
                    action: 'static/contact',
                    footer: {
                        template : {
                            id:"template-footer-form-1-1",
                            replace:{"{{submitLabel}}":"Send"}
                        }
                    },
                    reset:true, onSubmit : "GuestCtrl.onSubmitContactUs"
                }
            }
        },

        /* Profile Controller */
        "profile_home" : {
            "title" : "",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : true,
            "events" : {"pageShow":"ProfileCtrl.pageShowProfileHome"},
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["m"],
            "view" : {
                "template" : false ,//{url:"js/MVC/View/profile/home.html"},
                "x-pull" : true,
                "refresh" : "ProfileCtrl.refreshProfileHome"
            }
        },

        "profile_information" : {
            "title" : "Tell us about you",
            "isPageShow" : 0,
            "events" : {"pageShow" :"ProfileCtrl.pageShowProfileInformation"},
            "header" : "#template-header-single",
            "left-panel" : true,
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["m"],
            "view" : {
                "template" : {url:"js/MVC/View/profile/information.html"},
                "form" : {
                    id: 'frm_profile_information',
                    action: 'profile/update',
                    reset:true,
                    image : {element : "user_image" , multiple:false , profile:true },
                    footer: {
                        template : {
                            id:"template-footer-form-1-1",
                            replace:{"{{submitLabel}}":"Update"}
                        }
                    },
                    onSubmit : "ProfileCtrl.onSubmitProfileInformation"
                }
            }
        },

        "profile_address" : {
            "title" : "Residence Location",
            "isPageShow" : 0,
            "events" : {"pageInit":"ProfileCtrl.pageInitProfileAddress","pageShow" :"ProfileCtrl.pageShowProfileAddress"},
            "header" : "#template-header-single",
            "left-panel" : true,
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"#profile_home"},
            "access" : ["m"],
            "view" : {
                "template" : false,
                "form" : {
                    id: 'frm_profile_address',
                    action: 'profile/address',
                    reset:true,
                    onSubmit : "ProfileCtrl.onSubmitProfileAddress"
                }
            }
        },

        "profile_flat_mapping" : {
            "title" : "Map to Flat",
            "isPageShow" : 0,
            "events" : {"pageShow" :"ProfileCtrl.pageShowFlatMapping"},
            "header" : "#template-header-single",
            "left-panel" : true,
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"#profile_address"},
            "access" : ["m"],
            "view" : {
                "template" : {url:"js/MVC/View/profile/flat_mapping.html"},
                "form" : {
                    id: 'frm_flat_mapping',
                    action: 'profile/maptoflat',
                    reset:true,
                    footer: {
                        template : {
                            id:"template-footer-form-1-1",
                            replace:{"{{submitLabel}}":"Update"}
                        }
                    },
                    onSubmit : "ProfileCtrl.onSubmitMapToFlat"
                }
            }
        },

        "profile_approval" : {
            "title" : "Verification Pending",
            "isPageShow" : 0,
            "events" : {"pageShow" :"ProfileCtrl.pageShowProfileVerification"},
            "header" : "#template-header-single",
            "left-panel" : true,
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"#profile_address"},
            "access" : ["m"],
            "view" : {
                "template" : false,
            }
        },

        "profile_password" : {
            "title" : "Change Password",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : true,
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["m"],
            "view" : {
                "template" : {url:"js/MVC/View/profile/password.html"},
                "form" : {
                    id: 'frm_profile_password',
                    action: 'profile/password',
                    reset:true,
                    onSubmit : "ProfileCtrl.onSubmitProfilePassword",
                    footer: {
                        template : {
                            id:"template-footer-form-1-1",
                            replace:{"{{submitLabel}}":"Update"}
                        }
                    },

                }
            }
        },

        "profile_points" : {
            "title" : "Points",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : false,
            "events" : {"pageShow":"ProfileCtrl.pageShowProfilePoints"},
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["m"],
            "view" : {
                "template" : false,
                "x-pull" : true,
                "refresh" : "ProfileCtrl.refreshPagePoints",
                "listView" : "#listview_profile_points"
            }
        },


        /* Member */
        "member_list" : {
            "title" : "Neighbours",
            "isPageShow" : 0,
            "header" : "#template-header-double",
            "left-panel" : true,
            "events" : {"pageInit":"MemberCtrl.pageInitList","pageShow":"MemberCtrl.pageShowList"},
            "navigation" : {"swipe-left":false,"swipe-right":"#nearby_list","back":"Application.back"},
            "access" : ["sm"],
            "view" : {
                "template" : false,
                "x-pull" : true,
                "refresh" : "MemberCtrl.refreshList",
                "listView" : "#listView_member_list"
            }
        },

        "member_share" : {
            "title" : "Invite Contacts",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : true,
            "events" : {"pageInit":"MemberCtrl.pageInitShareContact","pageShow":"MemberCtrl.pageShowShareContact"},
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["sm"],
            "view" : {
                "template" : false,
                "x-pull" : true,
                "refresh" : "MemberCtrl.refreshShareContact",
                "listView" : "#listView_member_share"
            }
        },

        "member_profile" : {
            "title" : "",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : true,
            "events" : {"pageShow":"MemberCtrl.pageShowMemberProfile"},
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["sa"],
            "view" : {
                "template" : false,
                "x-pull" : true,
                "refresh" : "MemberCtrl.pageShowMemberProfile",
            }
        },

        "message_list" : {
            "title" : "Recent Messages",
            "isPageShow" : 0,
            "events" : {"pageShow":"MessageCtrl.pageShowRecentMessages"},
            "header" : "#template-header-double",
            "left-panel" : true,
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["sm"],
            "view" : {
                "template" : false,
                "x-pull" : true,
                "refresh" : "MessageCtrl.refreshRecentMessages",
                "listView" : "#listView_message_list"
            }
        },

        "message_chat" : {
            "title" : "",
            "isPageShow" : 0,
            "events" : {"pageShow" : "MessageCtrl.pageShowChat","pageHide" : "MessageCtrl.pageHideChat"},
            "header" : "#template-header-single",
            "left-panel" : false,
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["sm"],
            "view" : {
                "template" : false,
                "refresh" : "MessageCtrl.refreshChat",
                "form" : {id: 'frm_send_message', action: 'message/send', reset:true, onSubmit : "MessageCtrl.onSend"}
            }
        },


        /* Nearby Controller */
        "nearby_list" : {
            "title" : "Near By",
            "isPageShow" : 0,
            "header" : "#template-header-double",
            "left-panel" : true,
            "navigation" : {"swipe-left":"#member_list","swipe-right":"#soshare_wall","back":"Application.back"},
            "access" : ["sm"],
            "view" : {
                "template" : false
            }
        },

        "show_news" : {
            "title" : "Near by News",
            "isPageShow" : 0,
            "events" : {"pageShow":"NearByCtrl.pageShowNews"},
            "header" : "#template-header-single",
            "left-panel" : true,
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"#nearby_list"},
            "access" : ["sm"],
            "view" : {
                "template" : false,
                "x-pull" : true,
                "refresh" : "NearByCtrl.refreshNews",
                "listView" : "#listView_show_news"
            }
        },

        "nearby_atm" : {
            "title" : "ATM",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : true,
            "events" : {"pageShow":"NearByCtrl.pageShowPlaces"},
            "navigation" : {"swipe-left":"#nearby_list","swipe-right":"#nearby_park","back":"#nearby_list"},
            "access" : ["sm"],
            "view" : {
                "template" : false,
                "x-pull" : true,
                "refresh" : "NearByCtrl.refreshPlaces",
                "listView" : "#listView_nearby_atm"
            }
        },
        "nearby_pharmacy" : {
            "title" : "Pharmacy",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : true,
            "events" : {"pageShow":"NearByCtrl.pageShowPlaces"},
            "navigation" : {"swipe-left":"#nearby_list","swipe-right":"#nearby_park","back":"#nearby_list"},
            "access" : ["sm"],
            "view" : {
                "template" : false,
                "x-pull" : true,
                "refresh" : "NearByCtrl.refreshPlaces",
                "listView" : "#listView_nearby_pharmacy"
            }
        },
        "nearby_mall" : {
            "title" : "mall",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : true,
            "events" : {"pageShow":"NearByCtrl.pageShowPlaces"},
            "navigation" : {"swipe-left":"#nearby_list","swipe-right":"#nearby_park","back":"#nearby_list"},
            "access" : ["sm"],
            "view" : {
                "template" : false,
                "x-pull" : true,
                "refresh" : "NearByCtrl.refreshPlaces",
                "listView" : "#listView_nearby_mall"
            }
        },


        "nearby_transport" : {
            "title" : "Transport",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : true,
            "events" : {"pageShow":"NearByCtrl.pageShowPlaces"},
            "navigation" : {"swipe-left":"#nearby_list","swipe-right":"#nearby_park","back":"#nearby_list"},
            "access" : ["sm"],
            "view" : {
                "template" : false,
                "x-pull" : true,
                "refresh" : "NearByCtrl.refreshPlaces",
                "listView" : "#listView_nearby_transport"
            }
        },

        "nearby_park" : {
            "title" : "Park",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : true,
            "events" : {"pageShow":"NearByCtrl.pageShowPlaces"},
            "navigation" : {"swipe-left":"#nearby_transport","swipe-right":"#nearby_movie_theater","back":"#nearby_list"},
            "access" : ["sm"],
            "view" : {
                "template" : false,
                "x-pull" : true,
                "refresh" : "NearByCtrl.refreshPlaces",
                "listView" : "#listView_nearby_park"
            }
        },

        "nearby_movie_theater" : {
            "title" : "Near By Movie Theater",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : true,
            "events" : {"pageShow":"NearByCtrl.pageShowPlaces"},
            "navigation" : {"swipe-left":"#nearby_park","swipe-right":"#nearby_local_government_office","back":"#nearby_list"},
            "access" : ["sm"],
            "view" : {
                "template" : false,
                "x-pull" : true,
                "refresh" : "NearByCtrl.refreshPlaces",
                "listView" : "#listView_nearby_movie_theater"
            }
        },

        "nearby_local_government_office" : {
            "title" : "Government Office",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : true,
            "events" : {"pageShow":"NearByCtrl.pageShowPlaces"},
            "navigation" : {"swipe-left":"#nearby_movie_theater","swipe-right":"#nearby_department_store","back":"#nearby_list"},
            "access" : ["sm"],
            "view" : {
                "template" : false,
                "x-pull" : true,
                "refresh" : "NearByCtrl.refreshPlaces",
                "listView" : "#listView_nearby_local_government_office"
            }
        },

        "nearby_department_store" : {
            "title" : "Department Store",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : true,
            "events" : {"pageShow":"NearByCtrl.pageShowPlaces"},
            "navigation" : {"swipe-left":"#nearby_local_government_office","swipe-right":"#nearby_school","back":"#nearby_list"},
            "access" : ["sm"],
            "view" : {
                "template" : false,
                "x-pull" : true,
                "refresh" : "NearByCtrl.refreshPlaces",
                "listView" : "#listView_nearby_department_store"
            }
        },

        "nearby_school" : {
            "title" : "School",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : true,
            "events" : {"pageShow":"NearByCtrl.pageShowPlaces"},
            "navigation" : {"swipe-left":"#nearby_department_store","swipe-right":"#nearby_hospital","back":"#nearby_list"},
            "access" : ["sm"],
            "view" : {
                "template" : false,
                "x-pull" : true,
                "refresh" : "NearByCtrl.refreshPlaces",
                "listView" : "#listView_nearby_school"
            }
        },

        "nearby_hospital" : {
            "title" : "Hospital",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : true,
            "events" : {"pageShow":"NearByCtrl.pageShowPlaces"},
            "navigation" : {"swipe-left":"#nearby_school","swipe-right":"#nearby_restaurant","back":"#nearby_list"},
            "access" : ["sm"],
            "view" : {
                "template" : false,
                "x-pull" : true,
                "refresh" : "NearByCtrl.refreshPlaces",
                "listView" : "#listView_nearby_hospital"
            }
        },

        "nearby_restaurant" : {
            "title" : "Restaurant",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : true,
            "events" : {"pageShow":"NearByCtrl.pageShowPlaces"},
            "navigation" : {"swipe-left":"#nearby_hospital","swipe-right":false,"back":"#nearby_list"},
            "access" : ["sm"],
            "view" : {
                "template" : false,
                "x-pull" : true,
                "refresh" : "NearByCtrl.refreshPlaces",
                "listView" : "#listView_nearby_restaurant"
            }
        },

        "nearby_direction" : {
            "title" : "",
            "isPageShow" : 0,
            "events" : {"pageShow" : "NearByCtrl.pageShowDirection"},
            "header" : "#template-header-single",
            "left-panel" : false,
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["sm"],
            "view" : {"template" : false,}
        },


        /* Wall & Groups */
        "society_wall" : {
            "title" : "Society Wall",
            "isPageShow" : 0,
            "header" : "#template-header-double",
            "left-panel" : true,
            "events" : {"pageShow":"WallCtrl.pageShowWall"},
            "navigation" : {"swipe-left":"#group_joined","swipe-right":false,"back":"Application.back"},
            "access" : ["sm"],
            "view" : {
                "template" : {url:"js/MVC/View/wall/society_wall.html"},
                "x-pull" : true,
                "refresh" : "WallCtrl.refreshWall",
            }
        },

        "advertisement_detail" : {
            "title" : "Ads",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : false,
            "events" : {"pageShow":"WallCtrl.pageShowAds"},
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["sm"],
            "view" : {
                "template" : false,
                "x-pull" : true,
                "refresh" : "WallCtrl.refreshAds",
            }
        },

        "group_wall" : {
            "title" : "",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : false,
            "events" : {"pageShow":"WallCtrl.pageShowGroupWall","pageHide":"WallCtrl.pageHideGroupWall"},
            "navigation":{"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["sm"],
            "view" : {
                "template" : {url : "js/MVC/View/wall/group_wall.html"},
                "x-pull" : true,
                "refresh" : "WallCtrl.refreshGroupWall",
            }
        },

        "event_wall" : {
            "title" : "",
            "isPageShow" : 0,
            "events" : {"pageShow":"WallCtrl.pageShowEventWall","pageHide":"WallCtrl.pageHideEventWall"},
            "header" : "#template-header-single",
            "left-panel" : false,
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["sm"],
            "view" : {
                "template" : {"url" : "js/MVC/View/wall/event_wall.html"},
                "x-pull" : true,
                "refresh" : "WallCtrl.refreshEventWall"
            }
        },

        "soshare_wall" : {
            "title" : "<span style='text-transform: lowercase'>so</span>Share",
            "isPageShow" : 0,
            "header" : "#template-header-double",
            "left-panel" : true,
            "events" : {"pageShow":"WallCtrl.pageShowWallSoShare"},
            "navigation" : {"swipe-left":"#nearby_list","swipe-right":"#group_joined","back":"Application.back"},
            "access" : ["sm"],
            "view" : {
                "template" : {url:"js/MVC/View/wall/soshare_wall.html"},
                "x-pull" : true,
                "refresh" : "WallCtrl.refreshShowWallSoShare",
            }
        },

        "society_wall_detail" : {
            "title" : "",
            "isPageShow" : 0,
            "events" : {"pageShow":"WallCtrl.pageShowWallDetail","pageHide":"WallCtrl.pageHideWallDetail"},
            "header" : "#template-header-single",
            "left-panel" : false,
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["sm"],
            "view" : {
                "template" : false,
                "x-pull" : true,
                "refresh" : "WallCtrl.pageShowWallDetail"
            }
        },

        "group_joined" : {
            "title" : "Groups",
            "isPageShow" : 0,
            "header" : "#template-header-double",
            "left-panel" : true,
            "events" : {"pageShow":"WallCtrl.pageShowGroupJoined"},
            "navigation" : {"swipe-left":"#soshare_wall","swipe-right":"#society_wall","back":"Application.back"},
            "access" : ["sm"],
            "view" : {
                "template" : false,
                "x-pull" : true,
                "refresh" : "WallCtrl.refreshGroupJoined",
                "listView" : "#listView_member_list"
            }
        },

        "group_available" : {
            "title" : "Discover Groups",
            "isPageShow" : 0,
            "header" : "#template-header-double",
            "left-panel" : false,
            "events" : {"pageShow":"WallCtrl.pageShowGroupAvailable","pageHide":"WallCtrl.pageHideGroupAvailable"},
            "navigation" : {"swipe-left":"#soshare_wall","swipe-right":"#society_wall","back":"Application.back"},
            "access" : ["sm"],
            "view" : {
                "template" : false,
                "x-pull" : true,
                "refresh" : "WallCtrl.refreshGroupAvailable",
                "listView" : "#listView_member_list"
            }
        },

        "society_group_information" : {
            "title" : "",
            "isPageShow" : 0,
            "events" : {"pageShow":"WallCtrl.pageShowGroupInformation","pageHide":"WallCtrl.pageHideGroupInformation"},
            "header" : "#template-header-single",
            "left-panel" : false,
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["sm"],
            "view" : {
                "template" : false,
                "x-pull" : true,
                "refresh" : "WallCtrl.pageShowGroupInformation"
            }
        },

        "society_event_information" : {
            "title" : "",
            "isPageShow" : 0,
            "events" : {"pageShow":"WallCtrl.pageShowEventInformation","pageHide":"WallCtrl.pageHideEventInformation"},
            "header" : "#template-header-single",
            "left-panel" : false,
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["sm"],
            "view" : {
                "template" : false,
                "x-pull" : true,
                "refresh" : "WallCtrl.pageShowEventInformation"
            }
        },

        "add_group" : {
            "title" : "Create Group",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : false,
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["sm"],
            "view" : {
                "template" : {url:"js/MVC/View/wall/form/group/add.html"},
                "form" : {
                    id: 'frm_add_group',
                    action: 'wall/addgroup',
                    reset:true,
                    onSubmit : "WallCtrl.onSubmitAddGroup",
                    image : {element : "image",multiple:true},
                    footer: {
                        template : {
                            id:"template-footer-form-1-2",
                            replace:{"{{submitLabel}}":"Add"}
                        }
                    }
                }
            }
        },
        "edit_group" : {
            "title" : "Update Group",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : false,
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["sm"],
            "view" : {
                "template" : {url:"js/MVC/View/wall/form/group/edit.html"},
                "form" : {
                    id: 'frm_edit_group',
                    action: 'wall/editgroup',
                    reset:true,
                    onSubmit : "WallCtrl.onSubmitEditGroup",
                    image : {element : "image",multiple:true},
                    footer: {
                        template : {
                            id:"template-footer-form-1-2",
                            replace:{"{{submitLabel}}":"Update"}
                        }
                    }
                }
            }
        },

        "wall_add_post":{
            "title" : "Add Post",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : false,
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["sm"],
            "view" : {
                "template" : {url:"js/MVC/View/wall/form/wall-post/add.html"},
                "form" : {
                    id: 'frm_wall_add_post',
                    action: 'wall/addwallpost/postType/wall_post',
                    reset:true,
                    image : {element : "image",multiple:true},
                    onSubmit : "WallCtrl.onSubmitAddPost"
                }
            }
        },
        "wall_edit_post":{
            "title" : "Update Post",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : false,
            "events" : {"pageShow" : "WallCtrl.pageShowEditPost"},
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["sm"],
            "view" : {
                "template" : {url:"js/MVC/View/wall/form/wall-post/add.html"},
                "form" : {
                    id: 'frm_wall_edit_post',
                    action: 'wall/editwallpost/postType/wall_post',
                    reset:true,
                    image : {element : "image",multiple:true},
                    onSubmit : "WallCtrl.onSubmitEditPost"
                }
            }
        },

        "wall_add_notice":{
            "title" : "Add Notice",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : false,
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["sm"],
            "view" : {
                "template" : {url:"js/MVC/View/wall/form/notice/add.html"},
                "form" : {
                    id: 'frm_wall_add_notice',
                    action: 'wall/addwallpost/postType/notice',
                    reset:true,
                    image : {element : "image",multiple:true},
                    onSubmit : "WallCtrl.onSubmitAddPost"
                }
            }
        },
        "wall_edit_notice":{
            "title" : "Update Notice",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : false,
            "events" : {"pageShow" : "WallCtrl.pageShowEditPost"},
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["sm"],
            "view" : {
                "template" : {url:"js/MVC/View/wall/form/notice/add.html"},
                "form" : {
                    id: 'frm_wall_add_post',
                    action: 'wall/editwallpost/postType/notice',
                    reset:true,
                    image : {element : "image",multiple:true},
                    onSubmit : "WallCtrl.onSubmitEditPost"
                }
            }
        },

        "wall_add_event" : {
            "title" : "Add New Event",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : false,
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["sm"],
            "view" : {
                "template" : {url:"js/MVC/View/wall/form/event/add.html"},
                "form" : {
                    id: 'frm_add_wall_event',
                    action: 'wall/addwallpost/postType/event',
                    reset:true,
                    onSubmit : "WallCtrl.onSubmitAddPost",
                    image : {element : "image",multiple:true},
                    footer: {
                        template : {
                            id:"template-footer-form-1-2",
                            replace:{"{{submitLabel}}":"Post"}
                        }
                    }
                }
            }
        },
        "wall_edit_event" : {
            "title" : "Edit Event",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : false,
            "events" : {"pageShow" : "WallCtrl.pageShowEditPost"},
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["sm"],
            "view" : {
                "template" : {url:"js/MVC/View/wall/form/event/add.html"},
                "form" : {
                    id: 'frm_edit_wall_event',
                    action: 'wall/editwallpost/postType/event',
                    reset:true,
                    onSubmit : "WallCtrl.onSubmitEditPost",
                    image : {element : "image",multiple:true},
                    footer: {
                        template : {
                            id:"template-footer-form-1-2",
                            replace:{"{{submitLabel}}":"Update"}
                        }
                    }
                }
            }
        },

        "wall_add_survey" : {
            "title" : "Post New Survey",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : false,
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["sm"],
            "view" : {
                "template" : {url:"js/MVC/View/wall/form/survey/add.html"},
                "form" : {
                    id: 'frm_add_survey',
                    action: 'wall/addwallpost/postType/survey',
                    reset:true,
                    onSubmit : "WallCtrl.onSubmitAddPost",
                    footer: {
                        template : {
                            id:"template-footer-form-1-1",
                            replace:{"{{submitLabel}}":"Post"}
                        }
                    }
                }
            }
        },
        "wall_edit_survey" : {
            "title" : "Edit Survey",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : false,
            "events" : {"pageShow" : "WallCtrl.pageShowEditPost"},
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["sm"],
            "view" : {
                "template" : {url:"js/MVC/View/wall/form/survey/add.html"},
                "form" : {
                    id: 'frm_edit_survey',
                    action: 'wall/editwallpost/postType/survey',
                    reset:true,
                    onSubmit : "WallCtrl.onSubmitEditPost",
                    footer: {
                        template : {
                            id:"template-footer-form-1-1",
                            replace:{"{{submitLabel}}":"Update"}
                        }
                    }
                }
            }
        },

        "wall_add_classified" :{
            "title" : "Add Classified",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : false,
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["sm"],
            "view" : {
                "template" : {url:"js/MVC/View/wall/form/classified/add.html"},
                "form" : {
                    id: 'frm_add_classified',
                    action: 'wall/addwallpost/postType/classified',
                    dynamic : {"category_name" : {"type":"classified","label":"-- select category --"}},
                    reset:true,
                    onSubmit : "WallCtrl.onSubmitAddPost",
                    image : {element : "image",multiple:true},
                    footer: {
                        template : {
                            id:"template-footer-form-1-2",
                            replace:{"{{submitLabel}}":"Post"}
                        }
                    }
                }
            }
        },
        "wall_edit_classified" : {
            "title" : "Edit Classified",
            "isPageShow" : 0,
            "events" : {"pageShow":"WallCtrl.pageShowEditPost"},
            "header" : "#template-header-single",
            "left-panel" : false,
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["sm"],
            "view" : {
                "template" : {url:"js/MVC/View/wall/form/classified/add.html"},
                "form" : {
                    id: 'frm_edit_classified',
                    action: 'wall/editwallpost/postType/classified',
                    reset:true,
                    dynamic : {"category_name" : {"type":"classified","label":"-- select category --"}},
                    onSubmit : "WallCtrl.onSubmitEditPost",
                    image : {element : "image",multiple:true},
                    footer: {
                        template : {
                            id:"template-footer-form-1-2",
                            replace:{"{{submitLabel}}":"Update"}
                        }
                    }
                }
            }
        },

        "wall_add_car_pool":{
            "title" : "Offer Car Pool",
            "isPageShow" : 0,
            "events" : {"pageInit" : "WallCtrl.pageInitAddCarPool"},
            "header" : "#template-header-single",
            "left-panel" : false,
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["sm"],
            "view" : {
                "template" : {url:"js/MVC/View/wall/form/carpool/add.html"},
                "form" : {
                    id: 'frm_add_car_pool',
                    action: 'wall/addwallpost/postType/carpool',
                    reset:true,
                    onSubmit : "WallCtrl.onSubmitAddPost",
                    footer: {
                        template : {
                            id:"template-footer-form-1-1",
                            replace:{"{{submitLabel}}":"Post"}
                        }
                    }
                }

            }
        },
        "wall_edit_car_pool":{
            "title" : "Update Car Pool",
            "isPageShow" : 0,
            "events" : {"pageInit" : "WallCtrl.pageInitAddCarPool","pageShow" :  "WallCtrl.pageShowEditPost"},
            "header" : "#template-header-single",
            "left-panel" : false,
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["sm"],
            "view" : {
                "template" : {url:"js/MVC/View/wall/form/carpool/add.html"},
                "form" : {
                    id: 'frm_edit_car_pool',
                    action: 'wall/editwallpost/postType/carpool',
                    reset:true,
                    onSubmit : "WallCtrl.onSubmitEditPost",
                    footer: {
                        template : {
                            id:"template-footer-form-1-1",
                            replace:{"{{submitLabel}}":"Update"}
                        }
                    }
                }

            }
        },

        "wall_add_blood_request":{
            "title" : "Add Blood Request",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : false,
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["sm"],
            "view" : {
                "template" : {url:"js/MVC/View/wall/form/blood/add.html"},
                "form" : {
                    id: 'frm_add_blood_request',
                    action: 'wall/addwallpost/postType/blood',
                    reset:true,
                    onSubmit : "WallCtrl.onSubmitAddPost",
                    footer: {
                        template : {
                            id:"template-footer-form-1-1",
                            replace:{"{{submitLabel}}":"Post"}
                        }
                    }
                }
            }
        },
        "wall_edit_blood_request":{
            "title" : "Update Blood Request",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "events"  : {"pageShow" :  "WallCtrl.pageShowEditPost"},
            "left-panel" : false,
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["sm"],
            "view" : {
                "template" : {url:"js/MVC/View/wall/form/blood/add.html"},
                "form" : {
                    id: 'frm_edit_blood_request',
                    action: 'wall/editwallpost/postType/blood',
                    reset:true,
                    onSubmit : "WallCtrl.onSubmitEditPost",
                    footer: {
                        template : {
                            id:"template-footer-form-1-1",
                            replace:{"{{submitLabel}}":"Update"}
                        }
                    }
                }
            }
        },

        "wall_add_neigh_borrow":{
            "title" : "Add Neighborrow",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : false,
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["sm"],
            "view" : {
                "template" : {url:"js/MVC/View/wall/form/neighborrow/add.html"},
                "form" : {
                    id: 'frm_add_neighborrow',
                    action: 'wall/addwallpost/postType/neighborrow',
                    reset:true,
                    dynamic : {"category_name" : {"type":"neighborrow","label":"-- select category --"}},
                    onSubmit : "WallCtrl.onSubmitAddPost",
                    image : {element : "image",multiple:true},
                    footer: {
                        template : {
                            id:"template-footer-form-1-2",
                            replace:{"{{submitLabel}}":"Post"}
                        }
                    }
                }

            }
        },
        "wall_edit_neigh_borrow":{
            "title" : "Update Neighborrow",
            "isPageShow" : 0,
            "events" : {"pageShow" : "WallCtrl.pageShowEditPost"},
            "header" : "#template-header-single",
            "left-panel" : false,
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["sm"],
            "view" : {
                "template" : {url:"js/MVC/View/wall/form/neighborrow/add.html"},
                "form" : {
                    id: 'frm_edit_neighborrow',
                    action: 'wall/editwallpost/postType/neighborrow',
                    reset:true,
                    dynamic : {"category_name" : {"type":"neighborrow","label":"-- select category --"}},
                    onSubmit : "WallCtrl.onSubmitEditPost",
                    image : {element : "image",multiple:true},
                    footer: {
                        template : {
                            id:"template-footer-form-1-2",
                            replace:{"{{submitLabel}}":"Update"}
                        }
                    }
                }

            }
        },

        "wall_add_offer":{
            "title" : "Add Offer",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : false,
            "events"  : {},
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["sm"],
            "view" : {
                "template" : {url:"js/MVC/View/wall/form/offer/add.html"},
                "form" : {
                    id: 'frm_add_offer',
                    action: 'wall/addwallpost/postType/offer',
                    reset:true,
                    dynamic : {"category_name" : {"type":"offer","label":"-- select category --"}},
                    onSubmit : "WallCtrl.onSubmitAddPost",
                    image : {element : "image",multiple:true},
                    footer: {
                        template : {
                            id:"template-footer-form-1-2",
                            replace:{"{{submitLabel}}":"Post"}
                        }
                    }
                }
            }
        },
        "wall_edit_offer":{
            "title" : "Update Offer",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : false,
            "events" : {"pageShow":"WallCtrl.pageShowEditPost"},
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["sm"],
            "view" : {
                "template" : {url:"js/MVC/View/wall/form/offer/add.html"},
                "form" : {
                    id: 'frm_edit_offer',
                    action: 'wall/editwallpost/postType/offer',
                    reset:true,
                    dynamic : {"category_name" : {"type":"offer","label":"-- select category --"}},
                    onSubmit : "WallCtrl.onSubmitEditPost",
                    image : {element : "image",multiple:true},
                    footer: {
                        template : {
                            id:"template-footer-form-1-2",
                            replace:{"{{submitLabel}}":"Update"}
                        }
                    }
                }
            }
        },

        "wall_add_job":{
            "title" : "Post Job",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : false,
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["sm"],
            "view" : {
                "template" : {url:"js/MVC/View/wall/form/job/add.html"},
                "form" : {
                    id: 'frm_add_job',
                    action: 'wall/addwallpost/postType/job',
                    reset:true,
                    onSubmit : "WallCtrl.onSubmitAddPost",
                    image : {element : "job_attachment",multiple:true},
                    footer: {
                        template : {
                            id:"template-footer-form-1-2",
                            replace:{"{{submitLabel}}":"Post"}
                        }
                    }
                }
            }
        },
        "wall_edit_job":{
            "title" : "Update Job Information",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : false,
            "events"  : {"pageShow" :  "WallCtrl.pageShowEditJob"},
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["sm"],
            "view" : {
                "template" : {url:"js/MVC/View/wall/form/job/add.html"},
                "form" : {
                    id: 'frm_edit_job',
                    action: 'wall/editwallpost/postType/job',
                    reset:true,
                    onSubmit : "WallCtrl.onSubmitEditPost",
                    image : {element : "job_attachment",multiple:true},
                    footer: {
                        template : {
                            id:"template-footer-form-1-2",
                            replace:{"{{submitLabel}}":"Update"}
                        }
                    }
                }
            }
        },

        "wall_add_matrimonial":{
            "title" : "Post Matrimonial",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : false,
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["sm"],
            "view" : {
                "template" : {url:"js/MVC/View/wall/form/matrimonial/add.html"},
                "form" : {
                    id: 'frm_add_matrimonial',
                    action: 'wall/addwallpost/postType/matrimonial',
                    reset:true,
                    onSubmit : "WallCtrl.onSubmitAddPost",
                    image : {element : "image",multiple:true},
                    footer: {
                        template : {
                            id:"template-footer-form-1-2",
                            replace:{"{{submitLabel}}":"Post"}
                        }
                    }
                }
            }
        },
        "wall_edit_matrimonial":{
            "title" : "Update Matrimonial",
            "isPageShow" : 0,
            "header" : "#template-header-single",
            "left-panel" : false,
            "events"  : {"pageShow" :  "WallCtrl.pageShowEditPost"},
            "navigation" : {"swipe-left":false,"swipe-right":false,"back":"Application.back"},
            "access" : ["sm"],
            "view" : {
                "template" : {url:"js/MVC/View/wall/form/matrimonial/add.html"},
                "form" : {
                    id: 'frm_edit_matrimonial',
                    action: 'wall/editwallpost/postType/matrimonial',
                    reset:true,
                    onSubmit : "WallCtrl.onSubmitEditPost",
                    image : {element : "image",multiple:true},
                    footer: {
                        template : {
                            id:"template-footer-form-1-2",
                            replace:{"{{submitLabel}}":"Update"}
                        }
                    }
                }
            }
        },

    };

    return {

        getAllPageConfig : function(){return PAGE_CONFIGS;},

        getPageConfig : function(pageId){
            return PAGE_CONFIGS.hasOwnProperty(pageId)?PAGE_CONFIGS[pageId]:{};
        },

        getFormConfig : function(pageId){
            if(PAGE_CONFIGS.hasOwnProperty(pageId))
                if(PAGE_CONFIGS[pageId].hasOwnProperty("view") && PAGE_CONFIGS[pageId]['view'])
                    if(PAGE_CONFIGS[pageId]["view"].hasOwnProperty("form"))
                        return PAGE_CONFIGS[pageId]["view"]["form"];

            return false;
        },

        hasAccess : function(inObject){

            var isAllowed = false, isVerified = false, redirect = false, message = "";

            var pageConfigs = Application.getPageConfig(Application.clearIdHash(inObject.to));


            if(!pageConfigs.hasOwnProperty('access')){
                return {isAllowed:false};
            }

            var pageAccess = pageConfigs['access'];

            var userAccess = STORAGE.getTokenRoles();

            if(pageAccess.length>0){
                for(var index=0;index<pageAccess.length;index++){
                    var access = pageAccess[index];
                    if(access=="*"){isAllowed = true;break;}
                    if(access=="m" && userAccess.indexOf(access)!=-1){isAllowed = true;break;}
                    if(access=="g" && userAccess.indexOf(access)!=-1){isAllowed = true;break;}
                    if(access=="su" && userAccess.indexOf(access)!=-1){isAllowed = true;break;}
                    if(access=="sa" && userAccess.indexOf(access)!=-1){isAllowed = true;break;}
                    if(access=="sm" && userAccess.indexOf(access)!=-1){isAllowed = true;break;}
                    if(access=="sg" && userAccess.indexOf(access)!=-1){isAllowed = true;break;}
                }
            }

            if(isAllowed){
                return {isAllowed:true};
            }

            if(userAccess.indexOf("g")!=-1){
                message = "Please Login to continue !";
                return {isAllowed:false,message:message,redirect:"#user_login"}
            }

            if(userAccess.indexOf("su")!=-1){
                message = "Please map your society to continue";
                return {isAllowed:false,message:message,redirect:"#profile_address"}
            }

            if(userAccess.indexOf("sg")!=-1){
                var sdata = ProfileCtrl.getUserSociety("mapping_status");
                switch(sdata){
                    case "processing": message = "Your society mapping request is in process. Please contact your society admin to activate your account"; break;
                    case "blocked": message = "Your Account is blocked by admin. Please contact your society admin"; break;
                }
                message = "";
                return {isAllowed:false,message:message,redirect:"#profile_approval"}
            }

            return {isAllowed:false,message:"Access Denied!",redirect:inObject.from};
        },

        /* Extra */
        getActivePage : function(){
            return $.mobile.activePage.attr('id');
        },

        getPageShow : function(pageId){
            if(typeof pageId=="undefined"){
                pageId = Application.getActivePage();
            }
            var pageConfigs = Application.getPageConfig(pageId);
            return pageConfigs.hasOwnProperty("isPageShow")?pageConfigs['isPageShow']:0;
        },

        submitActiveForm : function(){

            var pageId = Application.getActivePage();

            var pageConfigs = Application.getPageConfig(pageId);

            if(pageConfigs && pageConfigs.hasOwnProperty('view') && pageConfigs['view'].hasOwnProperty('form')){
                var form = pageConfigs['view']['form'];
                if(form && form.hasOwnProperty('id')){
                    $("#"+form['id']).submit();
                }
            }
        },

        /* Header Footer & Layout Configs */

        setPageShow : function(pageId,value){

            if(typeof value=="undefined") {
                value = 0;
            }

            if(PAGE_CONFIGS.hasOwnProperty(pageId) && PAGE_CONFIGS[pageId].hasOwnProperty('isPageShow')){
                PAGE_CONFIGS[pageId]['isPageShow'] = value;
            }
        },

        setPageTitle : function(pageId,title){
            $('#'+pageId+" .header .row-1 .col-center a").html(title);
        },

        setPageHeader : function(pageId){

            var pageConfigs = Application.getPageConfig(pageId);

            if(pageConfigs.hasOwnProperty('header') && pageConfigs['header']){

                var template = $(pageConfigs['header']).html();

                $('#'+pageId).prepend(template);

                if(["soSmart_categories","soSmart_items","soSmart_cart"].indexOf(pageId)!=-1){
                    $('#'+pageId+" .header .col-right").html('<a href="#soSmart_cart" data-role="none" class="header-cart-badge"><i class="fa fa-shopping-bag"><span class="nbc cartTop">0</span></i></a>');
                }

                if(["society_wall_detail","society_event_information"].indexOf(pageId)!=-1){
                    $('#'+pageId+" .header .col-right").html('<a href="javascript:void(0)" data-role="none" onclick="WallCtrl.share_post();" ><i class="fa icon ion-ios-upload-outline"></i></a>');
                }

                if(pageConfigs.hasOwnProperty("title") &&  pageConfigs["title"]){
                    Application.setPageTitle(pageId,pageConfigs["title"]);
                }
            }
        },

        setPageFooter : function(pageId){

            var pageConfigs = Application.getPageConfig(pageId);

            if(pageConfigs.hasOwnProperty('footer') && typeof pageConfigs['footer']=="object"){

                var footer = pageConfigs['footer'];

                if(pageConfigs['footer'].hasOwnProperty('type')){
                    var footerType = pageConfigs['footer']["type"];

                    if(footerType=="submit"){
                        var template = $(footer['template']).html();

                        template = template.replace(new RegExp("{{label}}","g"),footer['label'])
                            .replace(new RegExp("{{onClick}}","g"),footer['onClick']);;

                        $('#'+pageId).append(template);

                    }
                }
            }


            /* Check for form Footers */
            if(pageConfigs["view"].hasOwnProperty("form") && pageConfigs["view"]["form"]) {
                var formConfig = pageConfigs["view"]["form"];
                if(formConfig.hasOwnProperty('footer') && typeof formConfig['footer']=="object"){
                    var footer = formConfig['footer'];
                    var template = $('#'+footer['template']['id']).html();
                    if(footer['template'].hasOwnProperty('replace')){
                        $.each(footer['template']['replace'],function(key,value){
                            template = template.replace(new RegExp(key,"g"),value);
                        });
                    }
                    $('#'+pageId).append(template);
                }
            }
        },

        setPageLeftPanel : function(pageId){

            var pageConfigs = Application.getPageConfig(pageId);

            if(pageConfigs.hasOwnProperty("left-panel") && pageConfigs['left-panel']){

                var template = $('#template-left-panel').html();

                $('#'+pageId).append(template);

                $('#' + pageId + ' #left-panel').css({"height": $(window).height() + "px", "overflow": "auto"});

            }
        },


        submitForm : function(){

            var page_id = $.mobile.activePage.attr('id');

            switch(page_id){
                case "society_wall_add_post" :$("#"+page_id+" #frm_add_wall_post").submit(); break;
                case "society_wall_add_notice" :$("#"+page_id+" #frm_add_wall_notice").submit(); break;
                case "society_wall_add_classified" :$("#"+page_id+" #frm_add_wall_classified").submit(); break;
                case "society_wall_add_event" :$("#"+page_id+" #frm_add_wall_event").submit(); break;
                case "society_wall_add_survey" :$("#"+page_id+" #frm_add_wall_survey").submit(); break;

                case "society_wall_edit_post" :$("#"+page_id+" #frm_edit_wall_post").submit(); break;
                case "society_wall_edit_notice" :$("#"+page_id+" #frm_edit_wall_notice").submit(); break;
                case "society_wall_edit_classified" :$("#"+page_id+" #frm_edit_wall_classified").submit(); break;
                case "society_wall_edit_event" :$("#"+page_id+" #frm_edit_wall_event").submit(); break;
                case "society_wall_edit_survey" :$("#"+page_id+" #frm_edit_wall_survey").submit(); break;


                case "sos_blood_request_add" :$("#"+page_id+" #frm_sos_blood_request_add").submit(); break;
                case "sos_carpool_request_add" :$("#"+page_id+" #frm_sos_carpool_offer_add").submit(); break;
                case "sos_rent_request_add" :$("#"+page_id+" #frm_sos_rent_offer_add").submit(); break;


                case "sosmart_veg_checkout" :$("#"+page_id+" #frm_cart_checkout").submit(); break;
                case "static_contact" :$("#"+page_id+" #frm_contact_us").submit(); break;

            }



        },

        /* -----------------  */
        getPageContainer : function(pageId){
            return "#"+pageId+ " .data-role-content .data-content-working";
        },

        managePageHeight  : function(){

            var screen = $.mobile.getScreenHeight();
            var page_id = "#"+$.mobile.activePage.attr('id');

            var header = $(page_id+" .ui-header").hasClass("ui-header-fixed") ? $(page_id+" .ui-header").outerHeight() - 1 : $(page_id+" .ui-header").outerHeight();

            var footer = $(page_id+" .ui-footer").hasClass("ui-footer-fixed") ? $(page_id+" .ui-footer").outerHeight() - 1 : $(page_id+" .ui-footer").outerHeight();

            var contentCurrent = $(page_id+" .ui-content").outerHeight() - $(page_id+" .ui-content").height();

            var content = screen - header - footer - contentCurrent;

            $(page_id+" .ui-content").height(content);
            //$(page_id+" .ui-content").width(window.innerWidth);
        },

        initPageBeforeCreate : function(){
            $(document).on('pagebeforecreate', '[data-role="page"]', function (event, ui) {

                var pageId = $(this).attr('id');
                Application.setPageHeader(pageId);
                Application.setPageFooter(pageId);
                Application.setPageLeftPanel(pageId);
            });
        },

        initPageBeforeChange : function(){
            $(document).on('pagebeforechange', function (e, data) {

                var to = data.toPage, from = data.options.fromPage;

                if (typeof to === 'string') {

                    var u = $.mobile.path.parseUrl(to);

                    to = u.hash || '#' + u.pathname.substring(1);

                    if (from) from = '#' + from.attr('id');

                    if (from && to) {

                        var access = Application.hasAccess({from: from, to: to});

                        var popUpPages = [
                            "#society_action_list_admin_block","#society_action_list_admin_unblock","#society_action_list_author","#society_action_list_user",
                            "#group_action_list_admin_block","#group_action_list_admin_unblock","#group_action_list_author","#group_action_list_user",
                            "#event_action_list_admin_block","#event_action_list_admin_unblock","#event_action_list_author","#event_action_list_user"
                        ];

                        if(popUpPages.indexOf(to)!=-1){
                            return true;
                        }

                        if (!access.isAllowed) {
                            if(access.message)
                                Notification.toast({message:access.message});

                            $.mobile.changePage(access.redirect);

                            e.preventDefault();
                            e.stopPropagation();
                        }

                        var readOnly = ["#wall_add_post","#wall_edit_post","#wall_add_event","#wall_edit_event","#wall_add_survey","#wall_edit_survey","#wall_add_classified","#wall_edit_classified",
                            "#add_group","#edit_group","#wall_add_blood_request","#wall_edit_blood_request","#wall_add_car_pool","#wall_edit_car_pool",
                            "#wall_add_neigh_borrow","#wall_add_neigh_borrow","#wall_edit_neigh_borrow","#wall_add_offer","#wall_edit_offer"
                        ];


                        if(ProfileCtrl.getUserSociety('role')=="readonly" && readOnly.indexOf(to)!=-1){
                            Notification.toast({message:"Your account is currently blocked by admin. Please contact live support.",alert:true});
                            e.preventDefault();
                            e.stopPropagation();
                        }


                        if(to=="#group_joined" && WallCtrl.getCountJoinedGroup()==0){
                            $.mobile.changePage("#group_available");
                            e.preventDefault();
                            e.stopPropagation();
                        }


                    }
                }
            });
        },

        initPageBeforeShow : function(){
            $(document).on('pagebeforeshow', '[data-role="page"]', function (event, ui) {

                var pageId = ui.toPage.attr('id');

                $('[data-selected-on]').removeClass('selected');

                $('[data-selected-on]').each(function (index, element) {
                    if ($(element).data('selected-on').split(",").indexOf(pageId) != -1) {
                        $(element).addClass("selected");
                    }
                });

                /*pr(pageId);

                 if(pageId=="society_wall" || pageId=="society_wall_notice" || pageId=="society_wall_event" || pageId=="society_survey" || pageId=="society_wall_classified"){

                 $("#"+pageId+' .header .row-2 a').each(function(index,element){

                 pr(element);

                 if($(element).attr('href')=="#"+pageId){
                 $(this).parent().addClass('selected');
                 }else{
                 $(this).parent().removeClass('selected');
                 }


                 });
                 }
                 */
            });
        },

        initPageInit : function(){

            $(document).on('pageinit', '[data-role="page"]', function (event, ui) {

                var pageId = $(this).attr('id');



                var pageConfigs = Application.getPageConfig(pageId);


                if(pageConfigs['view'].hasOwnProperty('template') && pageConfigs['view']['template']){
                    var templateUrl = pageConfigs['view']['template']['url'];
                    $.ajax({
                        url : templateUrl,
                        async:false,
                        cache:false,
                        success : function(data){

                            if(pageConfigs["view"].hasOwnProperty("form") && pageConfigs["view"]["form"]) {
                                data = data.replace(new RegExp("{{frmId}}","g"),pageConfigs["view"]["form"]['id'])
                                    .replace(new RegExp("{{frmAction}}","g"),pageConfigs["view"]["form"]['action']);
                            }



                            $(Application.getPageContainer(pageId)).html(data).trigger('create');
                        }
                    });
                }

                /* X-Pull */
                if(pageConfigs["view"].hasOwnProperty("x-pull") && pageConfigs["view"]["x-pull"]){
                    $("#"+pageId+" [data-role='content']").xpull({
                        'callback' :function(){
                            var callback = pageConfigs['view']['refresh'];
                            var x = eval(callback);
                            if (typeof x == 'function'){
                                x()
                            }
                        }
                    });
                }

                /* Load Validation */
                if(pageConfigs["view"].hasOwnProperty("form") && pageConfigs["view"]["form"]){

                    var formConfig = pageConfigs["view"]["form"];

                    if(pageId=="user_started"){
                        $("#"+pageId+" #"+formConfig['id']).validate({
                            rules: {
                                user_password: {
                                    required: true,
                                    minlength: 6,
                                    maxlength:20
                                },
                                user_cpassword: {
                                    required: true,
                                    minlength: 6,
                                    maxlength:20
                                },
                                user_activation_code: {
                                    required: true,
                                    minlength: 4,
                                    maxlength:4,
                                    number:true
                                },

                            },
                            submitHandler: function (form) {
                                var callback = formConfig['onSubmit'];
                                var x = eval(callback);
                                if (typeof x == 'function') {
                                    x(form)
                                }
                            }
                        });
                    }else{
                        $("#"+pageId+" #"+formConfig['id']).validate({
                            submitHandler: function (form) {
                                var callback = formConfig['onSubmit'];
                                var x = eval(callback);
                                if (typeof x == 'function') {
                                    x(form)
                                }
                            }
                        });
                    }

                    /* Add Dynamic categories  */
                    if(formConfig.hasOwnProperty('dynamic')){
                        var dyItems = formConfig['dynamic'];

                        $.each(dyItems,function(key,value){
                            // dynamic : {"category_name" : {"type":"classified","label":"-- select category --"}},
                            vs_debugger = $("#"+formConfig['id']+" #"+key);
                            var optionList = STORAGE.getOptionList(value.type);
                            $("#"+formConfig['id']+" #"+key).html("");
                            $("#"+formConfig['id']+" #"+key).append("<option value=''>"+value.label+"</option>");
                            $.each(optionList,function(oKey,oValue){
                                $("#"+formConfig['id']+" #"+key).append("<option value='"+oValue+"'>"+oValue+"</option>");
                            })
                            $("#"+formConfig['id']+" #"+key).selectmenu('refresh', true);
                        });


                    }
                }

                /* Bind PageInit Event  */
                if(pageConfigs.hasOwnProperty('events') && typeof pageConfigs['events']=="object"){
                    if(pageConfigs['events'].hasOwnProperty('pageInit') && pageConfigs['events']['pageInit']){
                        var x = eval(pageConfigs['events']['pageInit']);
                        if (typeof x == 'function') {
                            x(event, ui,pageId)
                        }
                    }
                }

            });
        },

        initPageShow : function(){
            $(document).on('pageshow', '[data-role="page"]', function (event, ui) {

                var pageId = $(this).attr('id');

                var pageConfig = Application.getPageConfig(pageId);


                Application.managePageHeight();

                /* Trigger PageShow Event */
                if(pageConfig.hasOwnProperty('events') && typeof pageConfig['events']=="object"){
                    if(pageConfig['events'].hasOwnProperty('pageShow') && pageConfig['events']['pageShow']){
                        var x = eval(pageConfig['events']['pageShow']);
                        if (typeof x == 'function') {
                            x(event, ui,pageId);
                        }
                    }
                }

                ProfileCtrl.myImages();/* Logged User Images */




            });
        },

        initPageHide : function(){
            $(document).on('pagehide', '[data-role="page"]', function (event, ui) {

                var pageId = $(this).attr('id');

                var pageConfig = Application.getPageConfig(pageId);

                if(pageConfig.hasOwnProperty('events') && typeof pageConfig['events']=="object"){
                    if(pageConfig['events'].hasOwnProperty('pageHide') && pageConfig['events']['pageHide']){
                        var x = eval(pageConfig['events']['pageHide']);
                        if (typeof x == 'function') {
                            x(event, ui,pageId)
                        }
                    }
                }

                /* Update PageShow */
                if(pageConfig.hasOwnProperty('isPageShow')){
                    PAGE_CONFIGS[pageId]['isPageShow'] += 1;
                }

                /* ResetForm */
                if(pageConfig.hasOwnProperty('view') && typeof pageConfig['view']=="object" && pageConfig['view'].hasOwnProperty('form')){
                    var form = pageConfig['view']['form'];
                    try{
                        $("#"+form['id']).trigger('reset');
                        $("#"+form['id']+" input[type='hidden']").val('');

                        $('.image-preview-container').empty();
                        $("#"+form['id']).validate().resetForm();
                    }catch(e){
                    }
                }



                $('.empty-pageHide').html("");
                $('.remove-pageHide').remove();



            });
        },


        /* Init Swipe Function */

        initSwipeRight : function(){
            $(document).on( "swiperight", ".ui-page", function( event ) {
                var pageId = $(this).attr("id");
                var pageConfigs = Application.getPageConfig(pageId);

                if(pageConfigs.hasOwnProperty('navigation')
                    && typeof pageConfigs['navigation'] =="object"
                    && pageConfigs['navigation'].hasOwnProperty('swipe-right')
                    && pageConfigs['navigation']['swipe-right']){

                    var swipeRight = pageConfigs['navigation']['swipe-right'];
                    $.mobile.changePage(swipeRight,{ transition: "slide",reverse : true});

                }else{
                    toggleLeftPanel();
                }

            });
        },

        initSwipeLeft : function(){

            $( document ).on( "swipeleft", ".ui-page", function( event ) {

                var pageId = $(this).attr("id");
                var pageConfigs = Application.getPageConfig(pageId);

                if(pageConfigs.hasOwnProperty('navigation')
                    && typeof pageConfigs['navigation'] =="object"
                    && pageConfigs['navigation'].hasOwnProperty('swipe-left')
                    && pageConfigs['navigation']['swipe-left']){

                    var swipeLeft = pageConfigs['navigation']['swipe-left'];

                    $.mobile.changePage(swipeLeft,{ transition: "slide",reverse : false});

                }else{
                    $("#"+ $.mobile.activePage.attr('id')+' #left-panel').panel('close');
                }
            });
        },


        /*
         * Method Application Back
         * */
        back : function(){
            var pageId= Application.getActivePage();
            var pageConfigs = Application.getPageConfig(pageId);
            if(pageConfigs.hasOwnProperty('navigation') && pageConfigs['navigation'].hasOwnProperty('back') && pageConfigs['navigation']["back"]!=""){
                var value = pageConfigs['navigation']["back"];
                if(value=="Application.back"){
                    history.back();
                }else{
                    $.mobile.changePage(value);
                }
            }else{
                history.back();
            }
        },
        goBack : function(){history.back();},

        clearIdHash : function(PageId){
            try{
                return PageId.replace(/#/gi,"");
            }catch(e){
                return PageId;
            }
        },

        init:function(){
            Application.setEnv();
            Application.initPageBeforeCreate();
            Application.initPageBeforeChange();
            Application.initPageBeforeShow();
            Application.initPageInit();
            Application.initPageShow();
            Application.initPageHide();
            Application.initSwipeLeft();
            Application.initSwipeRight();

            STORAGE.resetNews();


            /* Controller Init */
            ProfileCtrl.init();

        },

        /* Copy  */
        setEnv : function(){
            var hostname = window.location.hostname;
            var host = ["192.168.1.99","localhost"];
            if(host.indexOf(hostname)!=-1){
                ENV = "local";
            }else{
                ENV = "online";
            }
            return ENV;
        },
        getEnv : function(){return ENV;},

        goToRateUs : function(){
            var platform = AppDevice.getPlatform().toUpperCase();
            var url = "http://www.nearbymoms.com/App/Review?platform="+platform;
            cordova.InAppBrowser.open(url, "_system");
        },

        appShare: function(){
            var message = 'Connect with your neighborhood residents, shops and everything which matters in your real life.Download app http://bit.ly/21aJxqy';
            try{
                window.plugins.socialsharing.share(decodeURI(message))
            }catch(e){
            }
        },
        addToCalendar : function(object){
            var success = function(message){Notification.toast({message:"Added to calendar"});};
            var error = function(message){Notification.toast({message:message});};

            try{window.plugins.calendar.createEvent(object.title,object.location,object.note,object.start,object.end,success,error);}
            catch(e){pr(e);}
        },
    }

}();

var app = {


    initialize: function () {

        if(isApp){

            $.extend($.mobile,{
                loading: function() {
                    var arg = arguments ? arguments[0] : '';
                    if (arg == 'show'){
                        try{SpinnerPlugin.activityStart("Loading Please wait");}catch(e){pr(e);}
                    }else if (arg == 'hide') {
                        try{
                            SpinnerPlugin.activityStop();
                        }catch(e){pr(e);}
                    }
                    return { loader: function() {} }
                }
            });

            $('.ui-loader').hide();
        }

        app.onDocumentReady();

        document.addEventListener('load', app.onDeviceLoad, false);

        document.addEventListener('deviceready', app.onDeviceReady, false);

        document.addEventListener('offline', app.onDeviceOffline, false);

        document.addEventListener('online', app.onDeviceOnline, false);
    },

    onDocumentReady : function(){

        $(document).ready(function (e) {
            Application.init();

             $.mobile.loading('hide');

            if(!isApp){
                if(ProfileCtrl.getUserId()){
                    WallCtrl.sync_wall();
                }

                setInterval(function(){
                    if(ProfileCtrl.getUserId()){WallCtrl.sync_wall();}
                },1000*60*10);
            }

            $.mobile.loading('hide');
        });




    },
    onDeviceLoad: function (){},
    onDeviceOffline: function(){},
    onDeviceOnline: function (){},
    onDeviceReady: function () {
        isApp = true;
        AppDevice.init();
        PushCtrl.init();
        app.close();


        if(AppDevice.getPlatform().toUpperCase()=="ANDROID"){
            StatusBar.backgroundColorByHexString("#2e3d50");
        }

        if(ProfileCtrl.getUserId()){
            WallCtrl.sync_wall();
        }

        setInterval(function(){
            if(ProfileCtrl.getUserId()){WallCtrl.sync_wall();}
        },1000*60*10);

    },
    close : function(){
        document.addEventListener('backbutton', function(event){
            var pageids = ["society_wall","group_joined","soshare_wall","nearby_list","member_list"];
            var pageId = Application.getActivePage();
            if(pageids.indexOf(pageId)==-1){
                Application.back();
            }else{
                var confirm = function(){
                    event.preventDefault(); // EDIT
                    navigator.app.exitApp(); // exit the app
                };
                Notification.confirm({
                    message : "Do you want to Exit ?",
                    success:confirm
                });
            }
        });

    },

    accept : function(){alert('accept ');

        push.finish(function() {
            console.log('accept callback finished');
        }, function() {
            console.log('accept callback failed');
        }, data.additionalData.notId);

    },
    reject : function(){alert('reject');},
    maybe : function(){alert('maybe');},
    doDelete : function(){alert('doDelete');},
    cancel : function(){alert('cancel');},


};

app.initialize();

