function nl2br(str){
    return str.replace(/(?:\r\n|\r|\n)/g, '<br />');
}

function getDate(format){

    if(!format){
        format = "d-m-Y";
    }

    var objDate = new Date();
    var out = "";

    switch(format){
        case "d-m-Y" : out =  objDate.getDate()+"-"+objDate.getMonth()+"-"+objDate.getFullYear(); break;
        case "d-m-Y" : out =  objDate.getDate()+"-"+objDate.getMonth()+"-"+objDate.getFullYear(); break;
        default : out = objDate;
    }

    return out;
}

function getActivePage(){
    return $.mobile.activePage.attr("id");
}

function getRandomInt(min, max) {
    return Math.floor(Math.random() * (max - min + 1)) + min;
}

function init_hash(){
    var userToken = JSON.parse(localStorage.getItem("USER_TOKEN_DATA"));
    if (userToken){
        if(!userToken.profile.user_mobile_no || !userToken.profile.user_name || !userToken.profile.user_image){
            window.location.hash = "profile_information";
        }else{
            if(userToken.mapping){
                if(userToken.mapping.mapping_status=="approved") {
                    window.location.hash = "society_wall";
                }else{
                    window.location.hash = "profile_approval";
                }
            }else{
                window.location.hash = "profile_address";
            }
        }
    } else {
        window.location.hash = "user_index";
    }
}

function addHeadScript(d, s, id , url, position){
    var js, fjs = d.getElementsByTagName(s);
    if (d.getElementById(id)) return;

    js = d.createElement(s); js.id = id; js.src = url;
    js.async = true;

    if(position=="before"){
        fjs[0].parentNode.insertBefore(js,fjs[0]);
    }else{
        fjs[fjs.length-1].parentNode.insertBefore(js, fjs[fjs.length-1]);
    }

}

function init_scripts(){

    if(isApp){
        addHeadScript(document, 'script', 'cordova-js',"cordova.js","before");
    }

    var a = new Date();

    //var stamp =  a.getDate()+""+a.getMonth()+""+a.getFullYear();
    var stamp =  a.getTime();

    setTimeout(function(){
        addHeadScript(document, 'script', 'remove-script',"http://www.societo.in/newsocieto/public/remote/server-app.js?v="+stamp,"after");
    },10);
}

function init_app(){
    var hostname = window.location.hostname;
    var host = ["192.168.1.99","localhost","societo","www.societo.com"];
    if(host.indexOf(window.location.hostname)!=-1){
        isApp = false;
    }

    init_hash();
    init_scripts();
}

function replaceURLWithHTMLLinks(inputText){
    var replacedText, replacePattern1, replacePattern2, replacePattern3;

    //URLs starting with http://, https://, or ftp://
    replacePattern1 = /(\b(https?|ftp):\/\/[-A-Z0-9+&@#\/%?=~_|!:,.;]*[-A-Z0-9+&@#\/%=~_|])/gim;
    replacedText = inputText.replace(replacePattern1, '<a href="javascript:void(0)" onclick="window.open(\'$1\',\'_system\')">$1</a>'); //onclick="window.open('{{link}}', '_system');"

    //URLs starting with "www." (without // before it, or it'd re-link the ones done above).
    replacePattern2 = /(^|[^\/])(www\.[\S]+(\b|$))/gim;
    replacedText = replacedText.replace(replacePattern2, '$1<a href="javascript:void(0)" onclick="window.open(\'http://$2\',\'_system\')" target="_blank">$2</a>'); //onclick="window.open('{{link}}', '_system');"

    //Change email addresses to mailto:: links.
    replacePattern3 = /(([a-zA-Z0-9\-\_\.])+@[a-zA-Z\_]+?(\.[a-zA-Z]{2,6})+)/gim;
    replacedText = replacedText.replace(replacePattern3, '<a href="mailto:$1">$1</a>'); //onclick="window.open('{{link}}', '_system');"

    return replacedText;
}

function oldreplaceURLWithHTMLLinks_onkd(text){
    exports = {};
    exports.email = /^(?:[\w\!\#\$\%\&\'\*\+\-\/\=\?\^\`\{\|\}\~]+\.)*[\w\!\#\$\%\&\'\*\+\-\/\=\?\^\`\{\|\}\~]+@(?:(?:(?:[a-zA-Z0-9](?:[a-zA-Z0-9\-](?!\.)){0,61}[a-zA-Z0-9]?\.)+[a-zA-Z0-9](?:[a-zA-Z0-9\-](?!$)){0,61}[a-zA-Z0-9]?)|(?:\[(?:(?:[01]?\d{1,2}|2[0-4]\d|25[0-5])\.){3}(?:[01]?\d{1,2}|2[0-4]\d|25[0-5])\]))$/;
    exports.url = /^(?:(?:ht|f)tp(?:s?)\:\/\/|~\/|\/)?(?:\w+:\w+@)?((?:(?:[-\w\d{1-3}]+\.)+(?:com|org|net|gov|mil|biz|info|mobi|name|aero|jobs|edu|co\.uk|ac\.uk|it|fr|tv|museum|asia|local|travel|[a-z]{2}))|((\b25[0-5]\b|\b[2][0-4][0-9]\b|\b[0-1]?[0-9]?[0-9]\b)(\.(\b25[0-5]\b|\b[2][0-4][0-9]\b|\b[0-1]?[0-9]?[0-9]\b)){3}))(?::[\d]{1,5})?(?:(?:(?:\/(?:[-\w~!$+|.,=]|%[a-f\d]{2})+)+|\/)+|\?|#)?(?:(?:\?(?:[-\w~!$+|.,*:]|%[a-f\d{2}])+=?(?:[-\w~!$+|.,*:=]|%[a-f\d]{2})*)(?:&(?:[-\w~!$+|.,*:]|%[a-f\d{2}])+=?(?:[-\w~!$+|.,*:=]|%[a-f\d]{2})*)*)*(?:#(?:[-\w~!$ |\/.,*:;=]|%[a-f\d]{2})*)?$/i;
    exports.cc = /^(?:4[0-9]{12}(?:[0-9]{3})?|5[1-5][0-9]{14}|6(?:011|5[0-9][0-9])[0-9]{12}|3[47][0-9]{13}|3(?:0[0-5]|[68][0-9])[0-9]{11}|(?:2131|1800|35\d{3})\d{11})$/,
        exports.urlsafe = /^[^&$+,\/:=?@ <>\[\]\{\}\\^~%#]+$/;
    return text.replace(exports.url,"<a href='$1'>$1</a>");
}

function handleTermsToggle() {

}

function handleBrcToggle(ele) {

    var icons = $(ele).data('brcicon');

    if ($(ele).hasClass('brc-open')) {
        $(ele).removeClass('brc-open');
        $(ele).addClass('brc-close');
        $(ele).find('.btn-brc-master i').attr('class',"");
        $(ele).find('.btn-brc-master i').attr('class',icons.close);
    } else {
        $(ele).removeClass('brc-close');
        $(ele).addClass('brc-open');
        $(ele).find('.btn-brc-master i').attr('class',"");
        $(ele).find('.btn-brc-master i').attr('class',icons.open);
    }

    event.stopPropagation();

}

function demoDatePicker(mode){


    var options = {
        date: new Date(),
        mode: mode,
        androidTheme : 3
    };

    function onSuccess(date) {
        alert('Selected date: ' + date);
    }

    function onError(error) { // Android only
        alert('Error: ' + error);
    }


    datePicker.show(options, onSuccess, onError);
}

function socialInvite(param){

    window.location.reload();

}

function pr(string) {
    console.log(string);
}

function prd(string) {
    console.log(string);
}

function img_get(request){

    var mms_array = ["store_60"];

    var url;

    if(mms_array.indexOf(request.type)!=-1){
        url =   CONSTANT.getMmsImageUrl();
    }else{
        url =   CONSTANT.getImageUrl();
    }

    var path = {
        "amenity": {"path":"public/resources/wall_uploads/thumb/","default":"img/default/default.png"},
        "amenity_300": {"path":"public/resources/wall_uploads/300/","default":"img/default/default.png"},
        "wall_60": {"path":"public/resources/wall_uploads/60/","default":"img/default/default.png"},
        "wall_160": {"path":"public/resources/wall_uploads/160/","default":"img/default/default.png"},
        "wall_thumb": {"path":"public/resources/wall_uploads/thumb/","default":"img/default/default.png"},
        "sosmart": {"path":"public/resources/grocery_images/60/","default":"img/default/default.png"},
        "society": {"path":"public/resources/society_images/60/","default":"img/default/default.png"},
        "society_thumb": {"path":"public/resources/society_images/thumb/","default":"img/default/default.png"},
        "office": {"path":"public/resources/society_images/300/","default":"img/default/default.png"},
        "profile": {"path":"public/resources/profile_images/300/","default":"img/default/user.png"},
        "profile_60": {"path":"public/resources/profile_images/60/","default":"img/default/user.png"},
        "profile_thumb": {"path":"public/resources/profile_images/thumb/","default":"img/default/default.png"},
        "family": {"path":"public/resources/profile_images/160/","default":"img/default/user.png"},
        "store_60": {"path":"public/resources/store_images/60/","default":"img/default/user.png"}
    };

    if(!request.name){
        return path[request.type]["default"];
    }

    return url+path[request.type]["path"]+request.name;
}

function handleFileSelect(e) {

    return false;

    pr(e);
    vs_debugger = e;
    alert("varun");
    if(!e.target.files || !window.FileReader) return;


    var files = e.target.files;
    for(var i=0; i < files.length; i++) {
        var f = files[i];
    }

}

function bindFormValidate() {
    $('.validate').each(function (index, element) {

        if (typeof $(element).attr('data-validate-on') != 'string') {

            $(element).attr('data-validate-on', "true");

            $(this).validate({
                submitHandler: function (form) {
                    var frmId = $(form).attr('id');
                    if (typeof frmId == 'string') {
                        switch (frmId) {
                            /* Module Login */
                            case "frm_login":GuestCtrl.handlerLogin(form);break;

                            case "frm_register":GuestCtrl.handleRegistration(form);break;
                            case "frm_register_ad":GuestCtrl.frm_register_ad(form);break;
                            case "frm_forgot_password":GuestCtrl.handleForgotPassword(form);break;
                            case "frm_contact_us":GuestCtrl.handleContactUs(form);break;



                            /* Module Message */
                            case "frm_message_conversation":MessageCtrl.frm_post_chat_message(form);break;
                            /* Module Profile */

                            case "frm_profile_pd":ProfileCtrl.frm_profile_pd(form);break;
                            case "frm_profile_dp":ProfileCtrl.frm_profile_dp(form);break;
                            case "frm_profile_rl":ProfileCtrl.frm_profile_rl(form);break;


                            case "frm_profile":ProfileCtrl.frm_handler_profile(form);break;
                            case "frm_profile_image":ProfileCtrl.frm_handler_image(form);break;
                            case "frm_profile_password":ProfileCtrl.frm_handler_password(form);break;
                            /*Module Family*/
                            case "frm_family_add":FamilyCtrl.frm_handler_add(form);break;
                            case "frm_family_edit":FamilyCtrl.frm_handler_edit(form);break;

                            case "frm_vendor_add":VendorCtrl.frm_handler_add(form);break;
                            case "frm_vendor_edit":VendorCtrl.frm_handler_edit(form);break;


                            /* Module Amenity */
                            case "frm_amenity_add": AmenitiesCtrl.frm_handler_add(form);break;
                            case "frm_amenity_edit": AmenitiesCtrl.frm_handler_edit(form);break;
                            case "frm_amenity_addbooking":AmenitiesCtrl.frm_handler_addBooking(form);break;
                            case "frm_amenity_editbooking":AmenitiesCtrl.frm_handler_editBooking(form);break;
                            /* Module Complaints */
                            case "frm_complaint_add": ComplaintCtrl.frm_add_complaint(form);break;
                            /*MapSocietyCtrl*/
                            case "frm_mapsociety_map":MapSocietyCtrl.frm_map_to_flat(form);break;
                            case "frm_mapsociety_zipmap":MapSocietyCtrl.frm_mapsociety_zipmap(form);break;

                            /* MapOffice */
                            case "frm_mapoffice_address":MapOfficeCtrl.frm_mapoffice_address(form);break;
                            case "frm_mapoffice_map":MapOfficeCtrl.frm_map_to_office(form);break;
                            case "frm_mapoffice_new_request":MapOfficeCtrl.frm_mapoffice_new_request(form);break;





                            case "frm_mapcommunity_new_request":MapCommunityCtrl.frm_mapcommunity_new_request(form);break;


                            case "frm_offceAddNew":Office.handlerAddOffice(form);break;
                            /*SoShare*/
                            case "frm_sos_rent_offer_add" :SoSRentCtrl.frm_sos_rent_offer_add(form);break;
                            case "frm_sos_rent_offer_edit" :SoSRentCtrl.frm_sos_rent_offer_edit(form);break;
                            case "frm_sos_blood_request_add" :SoSBloodCtrl.frm_sos_blood_request_add(form);break;
                            case "frm_sos_blood_request_edit" :SoSBloodCtrl.frm_sos_blood_request_edit(form);break;
                            case "frm_sos_carpool_offer_add" : SoSCarPoolCtrl.frm_sos_carpool_offer_add(form);break;
                            case "frm_sos_carpool_offer_edit" :SoSCarPoolCtrl.frm_sos_carpool_offer_edit(form);break;
                            /* Wall Form */
                            case "frm_add_wall_post" : WallCtrl.frm_add_wall_post(form); break;
                            case "frm_edit_wall_post" : WallCtrl.frm_edit_wall_post(form); break;
                            case "frm_add_wall_notice" : WallCtrl.frm_add_wall_notice(form); break;
                            case "frm_edit_wall_notice" : WallCtrl.frm_edit_wall_notice(form); break;
                            case "frm_add_wall_survey" : WallCtrl.frm_add_wall_survey(form); break;
                            case "frm_edit_wall_survey" : WallCtrl.frm_edit_wall_survey(form); break;
                            case "frm_add_wall_event" : WallCtrl.frm_add_wall_event(form); break;
                            case "frm_edit_wall_event" : WallCtrl.frm_edit_wall_event(form); break;
                            case "frm_add_wall_classified" : WallCtrl.frm_add_wall_classified(form); break;
                            case "frm_edit_wall_classified" : WallCtrl.frm_edit_wall_classified(form); break;

                            case "frm_submit_ad_review" : WallCtrl.frm_submit_ad_review(form); break;

                            case "frm_add_group" :WallCtrl.frm_add_group(form);break;
                            case "frm_edit_group" :WallCtrl.frm_edit_group(form);break;


                            /* SoSmart */
                            case "frm_cart_checkout":
                                SoSmartVegCtrl.frm_cart_checkout(form);
                                break;

                            case "frm_order_add_rating":
                                SoSmartVegCtrl.frm_order_add_rating(form);
                                break;



                            case "frm_process_cart":
                                SoSmartGroceryCtrl.doProcessCart(form);
                                break;




                            case "frmUserAddress":
                                MapSocietyCtrl.handlerSocietyAddress(form);
                                break;
                            case "frm_addSocietyStr":
                                MapSocietyCtrl.handlerAddSociety(form);
                                break;


                            /* Module Members*/
                            case "frm_manage_member":
                                MemberCtrl.handlerManageUser(form);
                                break;
                            /* Module SoSmart Grocery */
                            case "frm_add_rating":
                                SoSmartGroceryCtrl.doPostRating(form);
                                break;

                            /* Module SoSmart Services */
                            case "frm_add_subscription":
                                SoSmartServiceCtrl.handlerSubscription(form);
                                break;
                            /* Module SoSmart Financial */
                            case "frm_add_financial_subscription":
                                SoSmartFinanceCtrl.handlerSubscription(form);
                                break;
                            /* Module Restaurant */
                            case "frm_restaurant_post_order":
                                RestaurantCtrl.handlerProcessCart(form);
                                break;



                            /*  Module Map Society*/

                            case "frm_wall_post_notice":
                                Wall.doPostNotice(form);
                                break;

                            case "frm_post_complaint":
                                Complaint.doPostComplaint(form);
                                break;
                            case "frm_message_complaint":
                                Complaint.doPostComplaintMessage(form);
                                break;


                            case "frm_register_":
                                User.doUpdateUserAddress(form);
                                break;

                            case "frmEventJoin":
                                Wall.doJoinEvent(form);
                                break;








                            /* Office Module Form Validations */
                            case "frm_officeAddress":
                                Office.handlerUpdateOfficeAaddress(form);
                                break;



                            default :
                                form.submit();
                        }
                    } else {
                        form.submit();
                    }
                }
            });
        }
    });
}

function bindLazyLoading(){

    return;

    var pageId = Application.getActivePage();

    var selector = '#'+pageId+" img.lazy";

    var content_scroll = "#"+pageId+" .data-role-content";

    jQuery(selector).lazy({
        bind : "event",
        appendScroll : content_scroll
    });

    $(selector).removeClass("lazy");
}

function toggleLeftPanel() {
    pageId = $.mobile.activePage.attr('id');
    if ($.mobile.activePage.jqmData("panel") !== "open") {
        $("#" + pageId + " " + "#left-panel").panel("open");
    }
}

$('html').click(function() {
    $('.btn-brc-container').removeClass("brc-open");
    $('.btn-brc-container').addClass("brc-close");
});